
/**
 * This is a simple class for generating a name for Aglets. This allows
 * a human to easily track and recognise the aglets. 
 *
 * @version     1.00    15/12/98    Initial Version.
 *
 * @author      Todd Papaioannou (T.Papaioannou@lboro.ac.uk)
 */
 
public class AgletNames {
    
    // Some class variables 
    String[] names = {"Stan", "Cartman", "Kyle", "Kenny", "Eric", "BeefCake", 
                      "Chef", "MrHand", "MrGarrison", "MrMayor"};
                      
    // Make sure these are constant across all classes so 
    // we don't get repeated names for any of our Slave's.
    private static int counter = 0;
    private static int other = 0;
    
    // Class constructor
    public AgletNames() { };
    
    /** 
     * Returns a unique human recognisable name for any aglet
     */
    public String getName() {
        
        return genNameString();
    }
    
    /**
     * Generates a unique name from the array of names. If we run out of names we
     * can cycle again by appending a number to increment each name. 
     */
    private String genNameString() {
     
        StringBuffer working = new StringBuffer();
        
        // Have we reached the end of the names list?
        if (counter == names.length ) {
            
            // Restart at the head of the list
            counter = 0;
            
            // Increment our additional number
            other++;
            
            // Generate the name string
            working.append(names[counter]);
            working.append(new Integer(other).toString());
        } else {
            working.append(names[counter]);
           
            // Do we need to add the number?
            if (other > 0)
                working.append(new Integer(other).toString());
        }    
        
        // Move to the next name
        counter++;
        
        return working.toString();
    }        
    
    /**
     * Returns the size of this list of names
     */
    public int getSize() {
        
        return names.length;
    }    

} /* End of Class */