import java.awt.*;

class Ball
{
  int nPosX;
  int nPosY;
  float fDeltaX;
  float fDeltaY;
  Color clrBall;
  Bricks brkParent;

  final static int RADIUS = 15;
  final static int DIAMETER = 2 * RADIUS;

/******************************************************/

  public Ball(Bricks b, int x, int y, float dx, float dy, Color c)
  {
    brkParent = b;
    nPosX = x;
    nPosY = y;
    fDeltaX = dx;
    fDeltaY = dy;
    clrBall = c;
  }

/******************************************************/

  public void paint(Graphics g)
  {
    g.setColor(new Color(0,0,0));
    g.fillOval(nPosX, nPosY, DIAMETER, DIAMETER);

    nPosX += fDeltaX;
    nPosY += fDeltaY;

    // Check left bound
    if(nPosX <= 0)
    {
      fDeltaX = -fDeltaX;
      nPosX = 0;
    }
    // Check right bound
    if(nPosX >= (Bricks.WIDTH - DIAMETER))
    {
      fDeltaX = -fDeltaX;
      nPosX = Bricks.WIDTH - DIAMETER;
    }
    // Check upper bound
    if(nPosY <= 0)
    {
      fDeltaY = -fDeltaY;
      nPosY = 0;
    }
    // Check lower bound
    if(nPosY >= (Bricks.HEIGHT - DIAMETER))
    {
      brkParent.nGameStatus = Bricks.GAME_LOST;
      fDeltaY = -fDeltaY;
      nPosY = Bricks.HEIGHT - DIAMETER;
    }

    g.setColor(clrBall);
    g.fillOval(nPosX, nPosY, DIAMETER, DIAMETER);
  }
}