import com.ibm.aglet.*;

/** 
 * This class provides a base aglet with which to work, the only additional 
 * functionality to an ibm aglet is the human readable name identifier. This
 * is not essential, but makes life easier!
 *
 * <B>Note</B>: Do not try to create a BaseAglet from Tahiti. It is abstract
 * and will cause an Instantiation error.
 * 
 * @version     1.00    15/12/98    Initial Version.
 *
 * @author      Todd Papaioannou (T.Papaioannou@lboro.ac.uk)
 */

public abstract class BaseAglet extends Aglet {
    
    private String name = null;
    
    // Set our name if we can
    public void onCreation(Object init) {
        
        AgletNames names = new AgletNames();
        name = names.getName();
    }    
            
    /**
     * Allow the name variable of this aglet to be filled
     */
    public void setName(String newName) {
        name = newName;
    }  
    
    /**
     * Return our name
     */
    public String getName() {
        return name;
    }    

} /* End of Class */