import java.awt.*;
import java.lang.Math;

class Brick
{
  Bricks brkParent;
  int nPosX;
  int nPosY;
  Color clrBrick;
  Ball bllBall;
  int nScore;

  final static int WIDTH = 75;
  final static int HEIGHT = 20;

/******************************************************/

  public Brick(Bricks bs, int x, int y, Color c, Ball b, int s)
  {
    brkParent = bs;
    nPosX = x;
    nPosY = y;
    clrBrick = c;
    bllBall = b;
    nScore = s;
  }

/******************************************************/

  public void paint(Graphics g)
  {
    g.setColor(clrBrick);
    g.fillRect(nPosX, nPosY, WIDTH, HEIGHT);
  }

/******************************************************/

  public boolean detectBall()
  {
    if(((bllBall.nPosY + Ball.DIAMETER) >= nPosY) &&
       ((bllBall.nPosY + Ball.DIAMETER) <= (nPosY + HEIGHT)))
    {
      if((((bllBall.nPosX + Ball.DIAMETER) > nPosX) &&
	 ((bllBall.nPosX + Ball.DIAMETER) < (nPosX + WIDTH))) ||
	 ((bllBall.nPosX < (nPosX + WIDTH)) &&
	 (bllBall.nPosX > nPosX)))
      {
	clrBrick = new Color(0, 0, 0);
	paint(brkParent.getGraphics());
	brkParent.nScore += nScore;
	bllBall.fDeltaY = -Math.abs(bllBall.fDeltaY);
	return(true);
      }
    }
    if((bllBall.nPosY <= (nPosY + HEIGHT)) &&
       (bllBall.nPosY >= nPosY))
    {
      if((((bllBall.nPosX + Ball.DIAMETER) > nPosX) &&
	 ((bllBall.nPosX + Ball.DIAMETER) < (nPosX + WIDTH))) ||
	 ((bllBall.nPosX < (nPosX + WIDTH)) &&
	 (bllBall.nPosX > nPosX)))
      {
	clrBrick = new Color(0, 0, 0);
	paint(brkParent.getGraphics());
	brkParent.nScore += nScore;
	bllBall.fDeltaY = Math.abs(bllBall.fDeltaY);
	return(true);
      }
    }

    return(false);
  }
}
