

import java.applet.Applet;
import java.awt.Color;
import java.awt.Event;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.util.Vector;

import broker.Broker;
import cpuJApi.AdaptStrategy;
import cpuJApi.CpuJApi;
import cpuJApi.CpuReserve;
import cpuJApi.ProcStats;

public class Bricks extends Applet implements Runnable
{
  final static int WIDTH = 543;
  final static int HEIGHT = 500;
  final static int BRICKS = 35;
  final static int SLEEP = 20;

  final static int GAME_STOPPED	= 0;
  final static int GAME_RUNNING	= 1;
  final static int GAME_WON	= 2;
  final static int GAME_LOST	= 3;

  long t1 = 0;
  int nTime1 = 0;
  int nTime2 = 0;
  int nScore = 0;
  int nTime = 0;
  int nBricks;
  boolean bOneTime = false;
  int nGameStatus = GAME_STOPPED;

    CpuReserve _cr;
    AdaptStrategy _as;

  Ball bllBall;
  Paddle pdlPad;
  Brick brkOne;
  Thread thrTime;
  Vector vctBricks;

  Font fntScore;
  String sScore;
  Font fntMessage;
  Font fntWelcome;
  Font fntInstr;

/******************************************************/

  public void init(CpuReserve cr, AdaptStrategy as)
  {
      _cr = cr;
      _as = as;

    setBackground(Color.black);
    resize(WIDTH, HEIGHT);


    fntScore = new Font("Courier", Font.BOLD, 12);
    fntMessage = new Font("Courier", Font.BOLD, 40);
    fntWelcome = new Font("Times", Font.BOLD, 48);
    fntInstr = new Font("Times", Font.BOLD, 32);

    thrTime = new Thread(this);
    thrTime.setPriority(Thread.MIN_PRIORITY);
    thrTime.start();
    thrTime.suspend();
  }

/******************************************************/

  public void start()
  {
    thrTime.resume();
  }

/******************************************************/

  public void newgame()
  {
    nGameStatus = GAME_RUNNING;

    nScore = 0;
    nTime = 0;
    nBricks = BRICKS;
    bOneTime = true;

    Graphics g = getGraphics();
    g.setColor(Color.black);
    g.fillRect(0, 0, WIDTH, HEIGHT);


    bllBall = new Ball(this, WIDTH/2, HEIGHT - 100, 4, -8, Color.red);
    pdlPad = new Paddle(bllBall);

    vctBricks = new Vector();
    for(int i=0; i<BRICKS/5; i++)
    {
      vctBricks.addElement(new Brick(this, i*78, 40, Color.yellow, bllBall, 30));
      vctBricks.addElement(new Brick(this, i*78, 63, Color.cyan, bllBall, 25));
      vctBricks.addElement(new Brick(this, i*78, 86, Color.magenta, bllBall, 20));
      vctBricks.addElement(new Brick(this, i*78, 109, Color.blue, bllBall, 15));
      vctBricks.addElement(new Brick(this, i*78, 132, Color.white, bllBall, 10));
    }
  }

/******************************************************/

  public void stop()
  {
    thrTime.suspend();
  }

/******************************************************/

  public synchronized void paint(Graphics g)
  {
    if(nGameStatus == GAME_RUNNING)
    {
      g.setFont(fntScore);
      g.setColor(Color.black);
      g.fillRect(0, 200, 150, 50);
      g.setColor(Color.white);

      sScore = "Score:  " + (new Integer(nScore)).toString();
      g.drawString(sScore, 10, 210);
      sScore = " Time:  " + (new Integer(nTime)).toString();
      g.drawString(sScore, 10, 230);

      long t2 = System.currentTimeMillis();
      if (t1 == 0) {
	  t1 = t2;
	  nTime1 = 0;
	  nTime2 = 0;
      }
      else if (t2 - t1 > 1000) {
	  t1 = t2;
	  nTime2 = nTime - nTime1;
	  nTime1 = nTime;
      }

      sScore = " Rate:  " + (new Integer(nTime2)).toString();
      g.drawString(sScore, 10, 250);

      if(bOneTime)
      {
        bOneTime = false;
        for(int j=0; j<BRICKS; j++)
        {
          brkOne = (Brick)vctBricks.elementAt(j);
  	  brkOne.paint(g);
        }
      }

      detectStuff();

      bllBall.paint(g);
      pdlPad.paint(g);
    }
    else if(nGameStatus == GAME_WON)
    {
      t1 = 0;
      g.setColor(Color.red);
      g.setFont(fntMessage);
      g.drawString("You Win!", 175, 250);
    }
    else if(nGameStatus == GAME_LOST)
    {
      t1 = 0;
      g.setColor(Color.red);
      g.setFont(fntMessage);
      g.drawString("You Lose!", 150, 250);
    }
    else if(nGameStatus == GAME_STOPPED)
    {
      t1 = 0;
      g.setColor(Color.red);
      g.setFont(fntWelcome);
      g.drawString("Welcome to BRICKS!", 30, 100);
      g.setColor(Color.cyan);
      g.setFont(fntInstr);
      g.drawString("Press 'S' to start.", 130, 250);
      g.drawString("Use 'K' and 'L' to move paddle.", 30, 300);
      g.drawString("Press 'Q' to stop.", 135, 350);
    }
  }

/******************************************************/

  public void detectStuff()
  {
    pdlPad.detectBall();

    for(int i=0; i<nBricks; i++)
    {
      brkOne = (Brick)vctBricks.elementAt(i);
      if(brkOne.detectBall())
      {
	vctBricks.removeElementAt(i);
	nBricks--;
      }
    }
    if(nBricks == 0)
    {
      nGameStatus = GAME_WON;
      DeleteStuff();
    }
  }

/******************************************************/

  public void DeleteStuff()
  {
  }

/******************************************************/

  public void update(Graphics g)
  {
    paint(g);
  }

/******************************************************/

  public void run()
  {
      
      /*if (_cr != null) {
	  if (!CpuJApi.init())
	      System.out.println("Error in init()");	    
	  if (!CpuJApi.reserve(_cr))
	      System.out.println("Error in reserve()");
	  if (_as != null) {
	      if (!CpuJApi.setAdaptStrategy(_as))
		  System.out.println("Error in setAdaptStrategy()");
	  }
	  if (!CpuJApi.start())
	      System.out.println("Error in start()");
      }*/
      
      Broker br = new Broker();
      Pid pid = new Pid();
      br.start();
      long ticket = br.reserve(pid.getPid(), _cr);
      if(ticket!=br.INVALID_TICKET)
      {
      		br.makeReservation(ticket);
      		br.startReservation(ticket);
      }
      	

      ProcStats ps = new ProcStats();

      while (true)
	{
	    nTime++;
	    repaint();
	    try
		{
		    if (_cr != null) {
			// thrTime.sleep(5);
			thrTime.yield();
			// sleep(cr.peakProcessingTime/2);
			CpuJApi.yield();
			// System.out.println("yielding");
		    }
		    else
			thrTime.sleep(SLEEP);
		}
	    catch(Exception e){}
	}

      /*
	while(true)
	{
	try
	{
        thrTime.sleep(SLEEP);
	}
	catch(Exception e){}
	
	nTime++;
	repaint();
	}
      */
  }

/******************************************************/

  public boolean keyDown(Event event, int key)
  {
      switch(key)
      {
	case 's':
	case 'S':  if(nGameStatus != GAME_RUNNING) newgame();
		   break;
	case 'q':
	case 'Q':  if(nGameStatus != GAME_STOPPED)
		   {
		     nGameStatus = GAME_STOPPED;
		     Graphics g = getGraphics();
		     g.setColor(Color.black);
		     g.fillRect(0, 0, WIDTH, HEIGHT);
		   }
		   break;
        case 'k':
	case 'K':  pdlPad.bMoveLeft = true;
		   break;
	case 'l':
	case 'L':  pdlPad.bMoveRight = true;
		   break;
      }

    return(true);
  }

/******************************************************/

  public boolean keyUp(Event event, int key)
  {
      switch(key)
      {
        case 'k':
	case 'K':  pdlPad.bMoveLeft = false;
		   break;
	case 'l':
	case 'L':  pdlPad.bMoveRight = false;
		   break;
      }

    return(true);
  }

    static void usage() {
	System.out.println("Usage: java RocksInSpace");
	System.out.println("  -reserve CPU_RT_PCPT period<ms> peakProcessingTime<ms>");
	System.out.println("           CPU_RT_PVPT period<ms> peakProcessingTime<ms> sustainableProcessingTime<ms> burstTolerance<ms>");
	System.out.println("           CPU_RT_ACPU peakProcessingUtil");
	System.out.println("  -adapt   ADAPT_EXPO windowSize alpha");
	System.out.println("           ADAPT_EXPO_UP windowSize alpha");
	System.out.println("           ADAPT_EXPO_RANGE windowSize alpha max min");
	System.out.println("           ADAPT_STAT windowSize nonconformFreq");
	System.exit(0);
    }

     public final static void main(String args[])
    {
	
	int mark = 0;
	int n;
	CpuReserve cr = null;
	AdaptStrategy as = null;
	
	while (mark < args.length) {
	    if (args[mark].equals("-reserve")) {
		mark++;
		cr = new CpuReserve();
		if ((n = cr.parse(args, mark)) == 0) {
		    usage();
		}
		mark += n;
	    } else if (args[mark].equals("-adapt")) {
		mark++;
		as = new AdaptStrategy();
		if ((n = as.parse(args, mark)) == 0) {
		    usage();
		}
		mark += n;
	    } else
		usage();
	}
	
	Frame		frame = new Frame("Bricks");
	Bricks	bricks = new Bricks();
	
	bricks.init(cr, as);
	bricks.start();
	
	frame.add("Center", bricks);
	frame.resize(WIDTH + 10, HEIGHT + 30);
	frame.show();
    }    

}
