package CORBAbroker.QMLcompiler;

//### This file created by BYACC 1.8(/Java extension  1.1)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//### Please send bug reports to rjamison@lincom-asg.com
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";






//#line 26 "qml.y"
  import java.io.*;
  import java.util.*;
  import java.net.URL;
//#line 19 "Parser.java"




/**
 * Encapsulates yacc() parser functionality in a Java
 *        class for quick code development
 */
public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[],stateptr;           //state stack
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
void state_push(int state)
{
  if (stateptr>=YYSTACKSIZE)         //overflowed?
    return;
  statestk[++stateptr]=state;
  if (stateptr>statemax)
    {
    statemax=state;
    stateptrmax=stateptr;
    }
}
int state_pop()
{
  if (stateptr<0)                    //underflowed?
    return -1;
  return statestk[stateptr--];
}
void state_drop(int cnt)
{
int ptr;
  ptr=stateptr-cnt;
  if (ptr<0)
    return;
  stateptr = ptr;
}
int state_peek(int relative)
{
int ptr;
  ptr=stateptr-relative;
  if (ptr<0)
    return -1;
  return statestk[ptr];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
boolean init_stacks()
{
  statestk = new int[YYSTACKSIZE];
  stateptr = -1;
  statemax = -1;
  stateptrmax = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//public class ParserVal is defined in ParserVal.java


String   yytext;//user variable to return contextual strings
ParserVal yyval; //used to return semantic vals from action routines
ParserVal yylval;//the 'lval' (result) I got from yylex()
ParserVal valstk[];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
void val_init()
{
  valstk=new ParserVal[YYSTACKSIZE];
  yyval=new ParserVal(0);
  yylval=new ParserVal(0);
  valptr=-1;
}
void val_push(ParserVal val)
{
  if (valptr>=YYSTACKSIZE)
    return;
  valstk[++valptr]=val;
}
ParserVal val_pop()
{
  if (valptr<0)
    return new ParserVal(-1);
  return valstk[valptr--];
}
void val_drop(int cnt)
{
int ptr;
  ptr=valptr-cnt;
  if (ptr<0)
    return;
  valptr = ptr;
}
ParserVal val_peek(int relative)
{
int ptr;
  ptr=valptr-relative;
  if (ptr<0)
    return new ParserVal(-1);
  return valstk[ptr];
}
//#### end semantic value section ####
public final static short NL=257;
public final static short CONTRACT=258;
public final static short DECREASING=259;
public final static short FOR=260;
public final static short FROM=261;
public final static short INCREASING=262;
public final static short NUMERIC=263;
public final static short PERCENTILE=264;
public final static short PROFILE=265;
public final static short REQUIRE=266;
public final static short TYPE=267;
public final static short DOUBLE=268;
public final static short LONG=269;
public final static short STRING=270;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,    0,    0,    0,    1,    4,    5,    5,    6,    8,
    8,    7,    7,    2,    9,   10,   10,   10,   10,   11,
   11,   11,   11,   11,    3,   12,   13,
};
final static short yylen[] = {                            2,
    0,    2,    2,    2,    5,    4,    4,    5,    3,    0,
    1,    1,    1,    5,    4,    5,    6,    5,    6,    1,
    1,    1,    2,    2,    5,    5,    3,
};
final static short yydefred[] = {                         1,
    0,    0,    0,    2,    3,    4,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    6,    0,   15,    0,    0,    0,
   20,    0,    0,    0,    0,    0,    0,    0,   26,   13,
   12,    0,    0,    0,    5,   24,   23,    0,    0,    0,
   14,   27,   25,    7,    0,    0,   11,    0,    0,    0,
    0,    9,    8,   18,   16,    0,    0,   19,   17,
};
final static short yydgoto[] = {                          1,
    4,    5,    6,    7,   20,   42,   43,   58,    8,   22,
   34,    9,   24,
};
final static short yysindex[] = {                         0,
 -263, -264,  -61,    0,    0,    0, -110,  -99,  -98,  -35,
 -243, -242, -241, -240, -235, -226,  -28, -224,  -23, -124,
  -50, -123, -234,  -88,    0, -227,    0, -254,  -19,  -18,
    0,  -21,  -17, -252,  -50,  -16,  -14,  -13,    0,    0,
    0,  -12, -221, -254,    0,    0,    0, -222, -222, -250,
    0,    0,    0,    0, -222,  -10,    0,   -9,   -8, -222,
 -222,    0,    0,    0,    0,   -7,   -6,    0,    0,
};
final static short yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -248, -246,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   -5,   -5,    0,
    0,    0,    0,    0,   -5,    0,    0,    0,    0,   -5,
   -5,    0,    0,    0,    0,    0,    0,    0,    0,
};
final static short yygindex[] = {                         0,
    0,    0,    0,    0,    0,   11,    0,  -46,    0,    0,
   21,    0,    0,
};
final static int YYTABLESIZE=199;
final static short yytable[] = {                         12,
   30,   36,   59,    2,   40,   10,    3,   41,   62,   32,
   31,   33,   13,   66,   67,   48,   49,   60,   61,   21,
   21,   22,   22,   14,   15,   16,   17,   18,   19,   21,
   23,   25,   26,   27,   28,   37,   38,   39,   44,   46,
   45,   55,   51,   47,   52,   53,   54,   57,   63,   64,
   65,   68,   69,   10,   56,   50,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   29,   35,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   11,
};
final static short yycheck[] = {                         61,
  125,  125,   49,  267,  259,  270,  270,  262,   55,   60,
   61,   62,  123,   60,   61,  268,  269,  268,  269,  268,
  269,  268,  269,  123,  123,   61,  270,  270,  270,  270,
  266,  258,   61,  258,   58,  270,  125,  265,   58,   61,
   59,  263,   59,   61,   59,   59,   59,  270,   59,   59,
   59,   59,   59,   59,   44,   35,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  270,  270,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,
};
final static short YYFINAL=1;
final static short YYMAXTOKEN=270;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,"':'","';'","'<'",
"'='","'>'",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
"'{'",null,"'}'",null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,"NL","CONTRACT","DECREASING","FOR","FROM",
"INCREASING","NUMERIC","PERCENTILE","PROFILE","REQUIRE","TYPE","DOUBLE","LONG",
"STRING",
};
final static String yyrule[] = {
"$accept : especification",
"especification :",
"especification : especification contract_type",
"especification : especification contract",
"especification : especification profile",
"contract_type : type_definition '{' dimension '}' ';'",
"type_definition : TYPE STRING '=' CONTRACT",
"dimension : STRING ':' dim_type ';'",
"dimension : dimension STRING ':' dim_type ';'",
"dim_type : order NUMERIC unit",
"unit :",
"unit : STRING",
"order : INCREASING",
"order : DECREASING",
"contract : contract_definition '{' values '}' ';'",
"contract_definition : STRING '=' STRING CONTRACT",
"values : STRING operand LONG unit ';'",
"values : values STRING operand LONG unit ';'",
"values : STRING operand DOUBLE unit ';'",
"values : values STRING operand DOUBLE unit ';'",
"operand : '='",
"operand : '<'",
"operand : '>'",
"operand : '>' '='",
"operand : '<' '='",
"profile : profile_definition '{' requirements '}' ';'",
"profile_definition : STRING FOR STRING '=' PROFILE",
"requirements : REQUIRE STRING ';'",
};

//#line 316 "qml.y"

  private Yylex lexer;


  private int yylex () {
    int yyl_return = -1;
    try {
      yylval = new ParserVal(0);
      yyl_return = lexer.yylex();
    }
    catch (IOException e) {
      System.err.println("IO error :"+e);
    }
    return yyl_return;
  }


  public void yyerror (String error) {
    System.err.println ("Error: " + error);
  }


  public Parser(Reader r) {
  	contract_types = new Hashtable();
    contracts = new Hashtable();
    dsrt_contracts = new Vector();
    profiles = new Hashtable();
    applications = new Hashtable();
    dimension_values = new Hashtable();
  
    lexer = new Yylex(r, this);
  }


  static boolean interactive;
  // Hash that associates a contract type to its dimensions
  static Hashtable contract_types;
  // Name of the entity being parsed.
  static String parsingEntity;
  static String dependingEntity;
  // Hashtable that contains the contracts defined
  static Hashtable contracts;
  // Hashtable that contains each contract's values of the dimensions
  static Hashtable dimension_values;
  // Vector that contains the DSRT contracts especifications
  static Vector dsrt_contracts;
  // Hashtable containing the profiles defined for each application
  static Hashtable profiles;
  // Hashtable containing the applications and the profiles defined for them
  static Hashtable applications;
  
  // Output debug/error file
  static File outFile;
  static FileWriter outWriter;

	public static Vector parse(String file) throws IOException
	{
	    System.out.println("BYACC/Java with JFlex QML->DSRT Compiler");
		Parser yyparser;
		
		outFile = new File("qml2dsrt.out");
		try
		{
			outWriter = new FileWriter(outFile);
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		
	    yyparser = new Parser(new FileReader(file));
	
	    yyparser.yyparse();
	
	    // After parsing the file, we can build the strings for reservation
	    Vector reservation_strings = new Vector();
	
	    for(Enumeration e = applications.keys(); e.hasMoreElements();) 
	    {
	      String profile = (String)e.nextElement();
	      String command_line = new String();
	      command_line = command_line.concat((String)applications.get(profile));
	      command_line = command_line.concat(" -reserve ");
	      
	      String contract = (String)profiles.get(profile);
	      String contract_type = (String)contracts.get(contract);
	      command_line = command_line.concat(contract_type);
	      command_line = command_line.concat(" ");
	      
	      //outWriter.write("DEBUG "+dimension_values);
	      
	      Vector dims = (Vector)contract_types.get(contract_type);
	      Hashtable dim_values = (Hashtable)dimension_values.get(contract);
	      
	      for(Enumeration e_dim = dims.elements(); e_dim.hasMoreElements();)
	      {
	      	String element=(String)e_dim.nextElement();
			try {
				outWriter.write(element+"="+(dim_values.get(element)).toString());
				outWriter.write("\n");
			}
			catch(IOException e2) {
				e2.printStackTrace();
			}
				
			command_line=command_line.concat((dim_values.get(element)).toString());
			command_line=command_line.concat(" ");
	      }
	      
	      reservation_strings.add(command_line);
	     }
	    
	    try {
	    	outWriter.write(reservation_strings.toString());
	    	outWriter.write("\n");
	    }
	    catch(IOException e2) {
			e2.printStackTrace();
		}
	    outWriter.close();
	    return(reservation_strings);
	}

	public static Vector parse(URL file) throws IOException
	{
	    System.out.println("BYACC/Java with JFlex QML->DSRT Compiler");
		Parser yyparser;
		
		outFile = new File("qml2dsrt.out");
		try
		{
			outWriter = new FileWriter(outFile);
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		
		BufferedReader in = new BufferedReader(new InputStreamReader(file.openStream()));
	    yyparser = new Parser(in);
	
	    yyparser.yyparse();
	
	    // After parsing the file, we can build the strings for reservation
	    Vector reservation_strings = new Vector();
	
	    for(Enumeration e = applications.keys(); e.hasMoreElements();) 
	    {
	      String profile = (String)e.nextElement();
	      String command_line = new String();
	      command_line = command_line.concat((String)applications.get(profile));
	      command_line = command_line.concat(" -reserve ");
	      
	      String contract = (String)profiles.get(profile);
	      String contract_type = (String)contracts.get(contract);
	      command_line = command_line.concat(contract_type);
	      command_line = command_line.concat(" ");
	      
	      //outWriter.write("DEBUG "+dimension_values);
	      
	      Vector dims = (Vector)contract_types.get(contract_type);
	      Hashtable dim_values = (Hashtable)dimension_values.get(contract);
	      
	      for(Enumeration e_dim = dims.elements(); e_dim.hasMoreElements();)
	      {
	      	String element=(String)e_dim.nextElement();
			try {
				outWriter.write(element+"="+(dim_values.get(element)).toString());
				outWriter.write("\n");
			}
			catch(IOException e2) {
				e2.printStackTrace();
			}
			command_line=command_line.concat((dim_values.get(element)).toString());
			command_line=command_line.concat(" ");
	      }
	      
	      reservation_strings.add(command_line);
	     }
	    
	    try {
	    	outWriter.write(reservation_strings.toString());
	    	outWriter.write("\n");
	    }
	    catch(IOException e2)
	    {
	    	e2.printStackTrace();	
	    }
	    outWriter.close();
	    return(reservation_strings);
	}
//#line 457 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 5:
//#line 59 "qml.y"
{ 
											/* try {
												outWriter.write(contract_types);
												outWriter.write("\n");
												}
												catch(IOException e) {
												e.printStackTrace();
												}
												*/ }
break;
case 6:
//#line 71 "qml.y"
{ 
											try {
												outWriter.write("[Y] Contract Type name: " + val_peek(2).sval);
												outWriter.write("\n");
											}
											catch(IOException e) {
												e.printStackTrace();
											}
                                            Vector dimensions = new Vector();
                                            contract_types.put(val_peek(2).sval, dimensions); 
                                            parsingEntity=new String(val_peek(2).sval);}
break;
case 7:
//#line 84 "qml.y"
{ ((Vector)contract_types.get(parsingEntity)).add(val_peek(3).sval);
                                     try {
                                     	outWriter.write("[Y] Dim name: " + val_peek(3).sval);
                                     	outWriter.write("\n");
                                    }
                                     catch(IOException e) {
										e.printStackTrace();
									} 
								}
break;
case 8:
//#line 93 "qml.y"
{ ((Vector)contract_types.get(parsingEntity)).add(val_peek(3).sval);
												try {
                                               		outWriter.write("[Y] Dim name: " + val_peek(3).sval);
                                               		outWriter.write("\n");
                                               	}
                                               	catch(IOException e) {
													e.printStackTrace();
												}
											 }
break;
case 15:
//#line 118 "qml.y"
{ if(contract_types.containsKey(val_peek(1).sval))
                          {    
                              try {
                              		outWriter.write("[Y] Contract " + val_peek(3).sval + " of Type " + val_peek(1).sval); 
                              		outWriter.write("\n"); 
                              	}
                              	catch(IOException e) {
									e.printStackTrace();
								}
						      parsingEntity=new String(val_peek(3).sval);
						      dependingEntity=new String(val_peek(1).sval);
						      contracts.put(val_peek(3).sval, val_peek(1).sval);
						      dimension_values.put(val_peek(3).sval, new Hashtable());
						  }
                          else
                          {
                              yyerror("Contract type " + val_peek(1).sval + " was not defined.");
						      /*exit(0);*/
						  } 
                   }
break;
case 16:
//#line 140 "qml.y"
{
					  if(dependingEntity.compareTo("CPU_RT_ACPU")==0)
					  {
					  		yyerror("Dimension [" + val_peek(4).sval + "] for Contract type [" + dependingEntity + "] requires a floating-point value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  }
					  else
					  {
					  		if(!((Vector)contract_types.get(dependingEntity)).contains(val_peek(4).sval))
                      		{
                           		yyerror("Dimension [" + val_peek(4).sval + "] not defined for Contract type [" + dependingEntity + "].");
					       		contracts.remove(parsingEntity);
					       		dimension_values.remove(parsingEntity);
				      		}
                      		else 
				      		{
					  			if(dimension_values.containsKey(parsingEntity))
					  			{
					    			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
					    			try {
					    				outWriter.write("[values] "+val_peek(2).ival);
					    				outWriter.write("\n");
					    			}
					    			catch(IOException e)
					    			{
					    				e.printStackTrace();
					    			}
					    			dim_val.put(val_peek(4).sval,new Long(val_peek(2).ival));
					    		}		
				      		} 
                 		}
                 	}
break;
case 17:
//#line 173 "qml.y"
{ 
      				   	if(dependingEntity.compareTo("CPU_RT_ACPU")==0)
					  	{
					  		yyerror("Dimension [" + val_peek(5).sval + "] for Contract type [" + dependingEntity + "] requires a floating-point value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  	}
					  	else
					  	{
      				   		if(!((Vector)contract_types.get(dependingEntity)).contains(val_peek(4).sval))
                       		{
                       			yyerror("Dimension [" + val_peek(4).sval + "] not defined for Contract type [" + dependingEntity + "].");
					  			contracts.remove(parsingEntity);
								dimension_values.remove(parsingEntity);
					   		}
                       		else
					   		{
					   			if(dimension_values.containsKey(parsingEntity))
						 		{
						   			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
						   			try {
						   				outWriter.write("[values] "+val_peek(2).ival);
						   				outWriter.write("\n");
						   			}
						   			catch(IOException e)
						   			{
						   				e.printStackTrace();
						   			}
						   			dim_val.put(val_peek(4).sval,new Long(val_peek(2).ival));
						 		}
					   		}
                   		}
                   	}
break;
case 18:
//#line 206 "qml.y"
{ 
      					if(dependingEntity.compareTo("CPU_RT_ACPU")!=0)
					  	{
					  		yyerror("Dimension [" + val_peek(4).sval + "] for Contract type [" + dependingEntity + "] requires an integer value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  	}
					  	else
					  	{
      						if(!((Vector)contract_types.get(dependingEntity)).contains(val_peek(4).sval))
                      		{
                           		yyerror("Dimension [" + val_peek(4).sval + "] not defined for Contract type [" + dependingEntity + "].");
					       		contracts.remove(parsingEntity);
					       		dimension_values.remove(parsingEntity);
				      		}
                      		else 
				      		{
					  			if(dimension_values.containsKey(parsingEntity))
					  			{
					    			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
					    			try {
					    				outWriter.write("[values] "+val_peek(2).dval);
					    				outWriter.write("\n");
					    			}
					    			catch(IOException e)
					    			{
					    				e.printStackTrace();
					    			}
					    			dim_val.put(val_peek(4).sval,new Double(val_peek(2).dval));
					    		}		
				      		} 
                 		}
                 	}
break;
case 19:
//#line 239 "qml.y"
{ 
      					if(dependingEntity.compareTo("CPU_RT_ACPU")!=0)
					  	{
					  		yyerror("Dimension [" + val_peek(5).sval + "] for Contract type [" + dependingEntity + "] requires an integer value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  	}
					  	else
					  	{
      						if(!((Vector)contract_types.get(dependingEntity)).contains(val_peek(4).sval))
                       		{
                       			yyerror("Dimension [" + val_peek(4).sval + "] not defined for Contract type [" + dependingEntity + "].");
					  			contracts.remove(parsingEntity);
								dimension_values.remove(parsingEntity);
					   		}
                       		else
					   		{
					   			if(dimension_values.containsKey(parsingEntity))
						 		{
						   			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
						   			try {
						   				outWriter.write("[values] "+val_peek(2).dval);
						   				outWriter.write("\n");
						   			}
						   			catch(IOException e) {
						   				e.printStackTrace();
						   			}
						   			dim_val.put(val_peek(4).sval,new Double(val_peek(2).dval));
						 		}
					   		}
                   		}
                   	}
break;
case 25:
//#line 280 "qml.y"
{ /*
							try {
								outWriter.write(profiles);
								outWriter.write("\n");
							}
							catch(IOException e) {
								e.printStackTrace();
							}*/ }
break;
case 26:
//#line 290 "qml.y"
{ 
							try {
								outWriter.write("[Y] Profile " + val_peek(4).sval + " for application " + val_peek(2).sval); 
								outWriter.write("\n"); 
							}
							catch(IOException e) {
								e.printStackTrace();
							}
                            parsingEntity=new String(val_peek(4).sval);
						    applications.put(val_peek(4).sval, val_peek(2).sval);			    
                        }
break;
case 27:
//#line 303 "qml.y"
{ if(!contracts.containsKey(val_peek(1).sval))
                   {
				     yyerror("Contract " + val_peek(1).sval + " not defined.");
				     applications.remove(parsingEntity);				     
				   } 
                   else
				   {
				     profiles.put(parsingEntity, val_peek(1).sval);
				   }			       
            }
break;
//#line 858 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
/**
 * A default run method, used for operating this parser
 * object in the background.  It is intended for extending Thread
 * or implementing Runnable.  Turn off with -Jnorun .
 */
public void run()
{
  yyparse();
}
//## end of method run() ########################################



//## Constructors ###############################################
/**
 * Default constructor.  Turn off with -Jnoconstruct .

 */
public Parser()
{
  //nothing to do
}


/**
 * Create a parser, setting the debug to true or false.
 * @param debugMe true for debugging, false for no debug.
 */
public Parser(boolean debugMe)
{
  yydebug=debugMe;
}
//###############################################################



}
//################### END OF CLASS ##############################
