/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (C) 2001 Gerwin Klein <lsf@jflex.de>                          *
 * All rights reserved.                                                    *
 *                                                                         *
 * This is a modified version of the example from                          *
 *   http://www.lincom-asg.com/~rjamison/byacc/                            *
 *                                                                         *
 * Thanks to Larry Bell and Bob Jamison for suggestions and comments.      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify    *
 * it under the terms of the GNU General Public License. See the file      *
 * COPYRIGHT for more information.                                         *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                 *
 *                                                                         *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

%{
  import java.io.*;
  import java.util.*;
  import java.net.URL;
%}
      

%token NL          /* newline  */

/* keywords */
%token CONTRACT
%token DECREASING
%token FOR
%token FROM
%token INCREASING
%token NUMERIC
%token PERCENTILE
%token PROFILE
%token REQUIRE
%token TYPE

/* values */
%token DOUBLE
%token LONG
%token STRING

%%

especification: 
		| especification contract_type
		| especification contract
		| especification profile
              ;

contract_type: type_definition "{" dimension "}" ";" { 
											/* try {
												outWriter.write(contract_types);
												outWriter.write("\n");
												}
												catch(IOException e) {
												e.printStackTrace();
												}
												*/ }
												
             ;

type_definition: TYPE STRING "=" CONTRACT { 
											try {
												outWriter.write("[Y] Contract Type name: " + $2.sval);
												outWriter.write("\n");
											}
											catch(IOException e) {
												e.printStackTrace();
											}
                                            Vector dimensions = new Vector();
                                            contract_types.put($2.sval, dimensions); 
                                            parsingEntity=new String($2.sval);}
               ;
  
dimension: STRING ":" dim_type ";" { ((Vector)contract_types.get(parsingEntity)).add($1.sval);
                                     try {
                                     	outWriter.write("[Y] Dim name: " + $1.sval);
                                     	outWriter.write("\n");
                                    }
                                     catch(IOException e) {
										e.printStackTrace();
									} 
								}
		| dimension STRING ":" dim_type ";" { ((Vector)contract_types.get(parsingEntity)).add($2.sval);
												try {
                                               		outWriter.write("[Y] Dim name: " + $2.sval);
                                               		outWriter.write("\n");
                                               	}
                                               	catch(IOException e) {
													e.printStackTrace();
												}
											 }
         ;

dim_type: order NUMERIC unit
        ;

unit: 
		| STRING
    ;

order: INCREASING
		| DECREASING
     ;

contract: contract_definition "{" values "}" ";"
        ;

contract_definition: STRING "=" STRING CONTRACT { if(contract_types.containsKey($3.sval))
                          {    
                              try {
                              		outWriter.write("[Y] Contract " + $1.sval + " of Type " + $3.sval); 
                              		outWriter.write("\n"); 
                              	}
                              	catch(IOException e) {
									e.printStackTrace();
								}
						      parsingEntity=new String($1.sval);
						      dependingEntity=new String($3.sval);
						      contracts.put($1.sval, $3.sval);
						      dimension_values.put($1.sval, new Hashtable());
						  }
                          else
                          {
                              yyerror("Contract type " + $3.sval + " was not defined.");
						      //exit(0);
						  } 
                   }
                   ;

values: STRING operand LONG unit ";" {
					  if(dependingEntity.compareTo("CPU_RT_ACPU")==0)
					  {
					  		yyerror("Dimension [" + $1.sval + "] for Contract type [" + dependingEntity + "] requires a floating-point value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  }
					  else
					  {
					  		if(!((Vector)contract_types.get(dependingEntity)).contains($1.sval))
                      		{
                           		yyerror("Dimension [" + $1.sval + "] not defined for Contract type [" + dependingEntity + "].");
					       		contracts.remove(parsingEntity);
					       		dimension_values.remove(parsingEntity);
				      		}
                      		else 
				      		{
					  			if(dimension_values.containsKey(parsingEntity))
					  			{
					    			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
					    			try {
					    				outWriter.write("[values] "+$3.ival);
					    				outWriter.write("\n");
					    			}
					    			catch(IOException e)
					    			{
					    				e.printStackTrace();
					    			}
					    			dim_val.put($1.sval,new Long($3.ival));
					    		}		
				      		} 
                 		}
                 	}	
      | values STRING operand LONG unit ";" { 
      				   	if(dependingEntity.compareTo("CPU_RT_ACPU")==0)
					  	{
					  		yyerror("Dimension [" + $1.sval + "] for Contract type [" + dependingEntity + "] requires a floating-point value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  	}
					  	else
					  	{
      				   		if(!((Vector)contract_types.get(dependingEntity)).contains($2.sval))
                       		{
                       			yyerror("Dimension [" + $2.sval + "] not defined for Contract type [" + dependingEntity + "].");
					  			contracts.remove(parsingEntity);
								dimension_values.remove(parsingEntity);
					   		}
                       		else
					   		{
					   			if(dimension_values.containsKey(parsingEntity))
						 		{
						   			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
						   			try {
						   				outWriter.write("[values] "+$4.ival);
						   				outWriter.write("\n");
						   			}
						   			catch(IOException e)
						   			{
						   				e.printStackTrace();
						   			}
						   			dim_val.put($2.sval,new Long($4.ival));
						 		}
					   		}
                   		}
                   	}
      | STRING operand DOUBLE unit ";" { 
      					if(dependingEntity.compareTo("CPU_RT_ACPU")!=0)
					  	{
					  		yyerror("Dimension [" + $1.sval + "] for Contract type [" + dependingEntity + "] requires an integer value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  	}
					  	else
					  	{
      						if(!((Vector)contract_types.get(dependingEntity)).contains($1.sval))
                      		{
                           		yyerror("Dimension [" + $1.sval + "] not defined for Contract type [" + dependingEntity + "].");
					       		contracts.remove(parsingEntity);
					       		dimension_values.remove(parsingEntity);
				      		}
                      		else 
				      		{
					  			if(dimension_values.containsKey(parsingEntity))
					  			{
					    			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
					    			try {
					    				outWriter.write("[values] "+$3.dval);
					    				outWriter.write("\n");
					    			}
					    			catch(IOException e)
					    			{
					    				e.printStackTrace();
					    			}
					    			dim_val.put($1.sval,new Double($3.dval));
					    		}		
				      		} 
                 		}
                 	}
      | values STRING operand DOUBLE unit ";" { 
      					if(dependingEntity.compareTo("CPU_RT_ACPU")!=0)
					  	{
					  		yyerror("Dimension [" + $1.sval + "] for Contract type [" + dependingEntity + "] requires an integer value.");
					       contracts.remove(parsingEntity);
					       dimension_values.remove(parsingEntity);
					  	}
					  	else
					  	{
      						if(!((Vector)contract_types.get(dependingEntity)).contains($2.sval))
                       		{
                       			yyerror("Dimension [" + $2.sval + "] not defined for Contract type [" + dependingEntity + "].");
					  			contracts.remove(parsingEntity);
								dimension_values.remove(parsingEntity);
					   		}
                       		else
					   		{
					   			if(dimension_values.containsKey(parsingEntity))
						 		{
						   			Hashtable dim_val = (Hashtable)dimension_values.get(parsingEntity);
						   			try {
						   				outWriter.write("[values] "+$4.dval);
						   				outWriter.write("\n");
						   			}
						   			catch(IOException e) {
						   				e.printStackTrace();
						   			}
						   			dim_val.put($2.sval,new Double($4.dval));
						 		}
					   		}
                   		}
                   	}
      ;

operand: "="
       | "<"
       | ">"
       | ">" "="
       | "<" "="
       ;

profile: profile_definition "{" requirements "}" ";" { /*
							try {
								outWriter.write(profiles);
								outWriter.write("\n");
							}
							catch(IOException e) {
								e.printStackTrace();
							}*/ }
       ;

profile_definition: STRING FOR STRING "=" PROFILE { 
							try {
								outWriter.write("[Y] Profile " + $1.sval + " for application " + $3.sval); 
								outWriter.write("\n"); 
							}
							catch(IOException e) {
								e.printStackTrace();
							}
                            parsingEntity=new String($1.sval);
						    applications.put($1.sval, $3.sval);			    
                        }
                  ;

requirements: REQUIRE STRING ";" { if(!contracts.containsKey($2.sval))
                   {
				     yyerror("Contract " + $2.sval + " not defined.");
				     applications.remove(parsingEntity);				     
				   } 
                   else
				   {
				     profiles.put(parsingEntity, $2.sval);
				   }			       
            }  
            ;
 
%%

  private Yylex lexer;


  private int yylex () {
    int yyl_return = -1;
    try {
      yylval = new ParserVal(0);
      yyl_return = lexer.yylex();
    }
    catch (IOException e) {
      System.err.println("IO error :"+e);
    }
    return yyl_return;
  }


  public void yyerror (String error) {
    System.err.println ("Error: " + error);
  }


  public Parser(Reader r) {
  	contract_types = new Hashtable();
    contracts = new Hashtable();
    dsrt_contracts = new Vector();
    profiles = new Hashtable();
    applications = new Hashtable();
    dimension_values = new Hashtable();
  
    lexer = new Yylex(r, this);
  }


  static boolean interactive;
  // Hash that associates a contract type to its dimensions
  static Hashtable contract_types;
  // Name of the entity being parsed.
  static String parsingEntity;
  static String dependingEntity;
  // Hashtable that contains the contracts defined
  static Hashtable contracts;
  // Hashtable that contains each contract's values of the dimensions
  static Hashtable dimension_values;
  // Vector that contains the DSRT contracts especifications
  static Vector dsrt_contracts;
  // Hashtable containing the profiles defined for each application
  static Hashtable profiles;
  // Hashtable containing the applications and the profiles defined for them
  static Hashtable applications;
  
  // Output debug/error file
  static File outFile;
  static FileWriter outWriter;

	public static Vector parse(String file) throws IOException
	{
	    System.out.println("BYACC/Java with JFlex QML->DSRT Compiler");
		Parser yyparser;
		
		outFile = new File("qml2dsrt.out");
		try
		{
			outWriter = new FileWriter(outFile);
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		
	    yyparser = new Parser(new FileReader(file));
	
	    yyparser.yyparse();
	
	    // After parsing the file, we can build the strings for reservation
	    Vector reservation_strings = new Vector();
	
	    for(Enumeration e = applications.keys(); e.hasMoreElements();) 
	    {
	      String profile = (String)e.nextElement();
	      String command_line = new String();
	      command_line = command_line.concat((String)applications.get(profile));
	      command_line = command_line.concat(" -reserve ");
	      
	      String contract = (String)profiles.get(profile);
	      String contract_type = (String)contracts.get(contract);
	      command_line = command_line.concat(contract_type);
	      command_line = command_line.concat(" ");
	      
	      //outWriter.write("DEBUG "+dimension_values);
	      
	      Vector dims = (Vector)contract_types.get(contract_type);
	      Hashtable dim_values = (Hashtable)dimension_values.get(contract);
	      
	      for(Enumeration e_dim = dims.elements(); e_dim.hasMoreElements();)
	      {
	      	String element=(String)e_dim.nextElement();
			try {
				outWriter.write(element+"="+(dim_values.get(element)).toString());
				outWriter.write("\n");
			}
			catch(IOException e2) {
				e2.printStackTrace();
			}
				
			command_line=command_line.concat((dim_values.get(element)).toString());
			command_line=command_line.concat(" ");
	      }
	      
	      reservation_strings.add(command_line);
	     }
	    
	    try {
	    	outWriter.write(reservation_strings.toString());
	    	outWriter.write("\n");
	    }
	    catch(IOException e2) {
			e2.printStackTrace();
		}
	    outWriter.close();
	    return(reservation_strings);
	}

	public static Vector parse(URL file) throws IOException
	{
	    System.out.println("BYACC/Java with JFlex QML->DSRT Compiler");
		Parser yyparser;
		
		outFile = new File("qml2dsrt.out");
		try
		{
			outWriter = new FileWriter(outFile);
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		
		BufferedReader in = new BufferedReader(new InputStreamReader(file.openStream()));
	    yyparser = new Parser(in);
	
	    yyparser.yyparse();
	
	    // After parsing the file, we can build the strings for reservation
	    Vector reservation_strings = new Vector();
	
	    for(Enumeration e = applications.keys(); e.hasMoreElements();) 
	    {
	      String profile = (String)e.nextElement();
	      String command_line = new String();
	      command_line = command_line.concat((String)applications.get(profile));
	      command_line = command_line.concat(" -reserve ");
	      
	      String contract = (String)profiles.get(profile);
	      String contract_type = (String)contracts.get(contract);
	      command_line = command_line.concat(contract_type);
	      command_line = command_line.concat(" ");
	      
	      //outWriter.write("DEBUG "+dimension_values);
	      
	      Vector dims = (Vector)contract_types.get(contract_type);
	      Hashtable dim_values = (Hashtable)dimension_values.get(contract);
	      
	      for(Enumeration e_dim = dims.elements(); e_dim.hasMoreElements();)
	      {
	      	String element=(String)e_dim.nextElement();
			try {
				outWriter.write(element+"="+(dim_values.get(element)).toString());
				outWriter.write("\n");
			}
			catch(IOException e2) {
				e2.printStackTrace();
			}
			command_line=command_line.concat((dim_values.get(element)).toString());
			command_line=command_line.concat(" ");
	      }
	      
	      reservation_strings.add(command_line);
	     }
	    
	    try {
	    	outWriter.write(reservation_strings.toString());
	    	outWriter.write("\n");
	    }
	    catch(IOException e2)
	    {
	    	e2.printStackTrace();	
	    }
	    outWriter.close();
	    return(reservation_strings);
	}