import junit.framework.TestCase;

import org.omg.CORBA.ORB;
import org.omg.CosEventChannelAdmin.EventChannel;
import org.omg.CosEventChannelAdmin.EventChannelHelper;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.CosNaming.NamingContextPackage.CannotProceed;
import org.omg.CosNaming.NamingContextPackage.InvalidName;
import org.omg.CosNaming.NamingContextPackage.NotFound;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

/*
 * Created on Aug 25, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class NSTest extends TestCase
{
	ORB orb;
	EventChannel ecs;
	NamingContextExt nc;
	
	/**
	 * Constructor for NSTest.
	 * @param arg0
	 */
	public NSTest(String arg0)
	{
		super(arg0);
	}
	
	
	/* (non-Javadoc)
	 * @see junit.framework.TestCase#runTest()
	 */
	protected void runTest() throws Throwable
	{
		/*testORB();
		testNS();
		testEC();
		testPOA();
		testDummy();*/
	}

	/* (non-Javadoc)
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception
	{
		nc = null;	
	}
	
	public void testORB()
	{
		orb = null;
		orb = ORB.init();
				
		assertNotNull(orb);
		
	}
	
	public void testNS() throws org.omg.CORBA.ORBPackage.InvalidName
	{
		nc =NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));
		assertNotNull(nc);
	}
	
	public void testEC() throws NotFound, CannotProceed, InvalidName
	{
		ecs = EventChannelHelper.narrow(nc.resolve(nc.to_name("eventchannel.resource")));
		assertNotNull(ecs);
	}

	public void testPOA() throws org.omg.CORBA.ORBPackage.InvalidName
	{
		 POA rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
		 assertNotNull(rootpoa);
	}
	
	public void testDummy()
	{
		assertEquals(8,10);
	}
	
	public void testDummy2()
	{
		assertNotNull(null);	
	}
	
	
}
