import java.awt.*;
import java.lang.Math;

class Paddle
{
  Ball bllBall;
  int nPosX;
  int nPosY;
  Color clrPaddle = new Color(0, 255, 0);
  boolean bMoveLeft = false;
  boolean bMoveRight = false;
  boolean bFirstTime = true;

  final static int WIDTH = 80;
  final static int HEIGHT = 15;
  final static int INCREMENT = 10;

  final static float X_MULT_SIDE = (float)1.2;
  final static float Y_MULT_SIDE = (float)0.8;
  final static float X_MULT_INC = (float)1.1;
  final static float X_MULT_DEC = (float)0.9;

/******************************************************/

  public Paddle(Ball b)
  {
    bllBall = b;
    nPosX = Bricks.WIDTH/2 - WIDTH/2;
    nPosY = Bricks.HEIGHT - 2*HEIGHT;
  }

/******************************************************/

  public void paint(Graphics g)
  {
    if(bMoveLeft || bMoveRight)
    {
      g.setColor(Color.black);
      g.fillRect(nPosX, nPosY, WIDTH, HEIGHT);
    }

    if(bMoveLeft)
    {
      nPosX -= INCREMENT;
      if(nPosX < 0)
	nPosX = 0;
    }
    if(bMoveRight)
    {
      nPosX += INCREMENT;
      if(nPosX > Bricks.WIDTH - WIDTH)
	nPosX = Bricks.WIDTH - WIDTH;
    }

    if(bMoveLeft || bMoveRight || bFirstTime)
    {
      g.setColor(clrPaddle);
      g.fillRect(nPosX, nPosY, WIDTH, HEIGHT);
      bFirstTime = false;
    }
  }

/******************************************************/

  public void detectBall()
  {
    // ball is potentially touching the paddle
    if((bllBall.nPosY + Ball.DIAMETER) >= nPosY)
    {
      if(((bllBall.nPosX + Ball.RADIUS) >= nPosX) &&
	 ((bllBall.nPosX + Ball.RADIUS) <= (nPosX + WIDTH)))
      {
        bFirstTime = true;
//	if(!bMoveLeft && !bMoveRight)
        bllBall.fDeltaY = -Math.abs(bllBall.fDeltaY);
//	else
	{
	  if(bMoveLeft)
	  {
	    if(bllBall.fDeltaX > 0)
	      bllBall.fDeltaX *= X_MULT_DEC;
	    else
	      bllBall.fDeltaX *= X_MULT_INC;
	  }
	  else
	  {
	    if(bllBall.fDeltaX > 0)
	      bllBall.fDeltaX *= X_MULT_INC;
	    else
	      bllBall.fDeltaX *= X_MULT_DEC;
	  }
	}
      }

      if(((bllBall.nPosX + Ball.DIAMETER) >= nPosX) &&
	 ((bllBall.nPosX + Ball.RADIUS) <= nPosX))
      {
	bllBall.fDeltaY = -Math.abs(bllBall.fDeltaY) * Y_MULT_SIDE;
	bllBall.fDeltaX = -Math.abs(bllBall.fDeltaX) * X_MULT_SIDE;
	bFirstTime = true;
      }

      if((bllBall.nPosX <= (nPosX + WIDTH)) &&
	 ((bllBall.nPosX + Ball.RADIUS) >= (nPosX + WIDTH)))
      {
	bllBall.fDeltaY = -Math.abs(bllBall.fDeltaY) * Y_MULT_SIDE;
	bllBall.fDeltaX = Math.abs(bllBall.fDeltaX) * X_MULT_SIDE;
	bFirstTime = true;
      }
    }
  }
}