/*
 * Created on Oct 15, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package broker;

import Pid;
import junit.framework.TestCase;
import cpuJApi.CpuReserve;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class TestBroker extends TestCase
{
	Broker bk;
	Pid pid;
	String reservePossible[];
	String reserveImpossible[];
	CpuReserve crPossible;
	CpuReserve crImpossible;

	/**
	 * Constructor for TestBroker.
	 * @param arg0
	 */
	public TestBroker(String arg0)
	{
		super(arg0);
	}

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception
	{
		bk=new Broker();
		
		reservePossible = new String[3];
		reservePossible[0] = new String("CPU_RT_PCPT");
		reservePossible[1] = new String("50");
		reservePossible[2] = new String("30");
		
		reserveImpossible = new String[3];
		reserveImpossible[0] = new String("CPU_RT_PCPT");
		reserveImpossible[1] = new String("50");
		reserveImpossible[2] = new String("50");
				
		crPossible = new CpuReserve();
		crPossible.parse(reservePossible, 0);
		
		crImpossible = new CpuReserve();
		crImpossible.parse(reserveImpossible, 0);
		
		pid=new Pid();
	}

	/*
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception
	{
		
	}
	
	public void testSetUp()
	{
		assertNotNull("cr is null", crPossible);
		assertNotNull("cr is null", crImpossible);
		assertNotNull("bk is null", bk);
	}
	
	public void testReservationSuccessful()
	{
		long tktID = bk.reserve(pid.getPid(), crPossible);
		assertTrue(tktID!=-1);
	}
	
	public void testReservationUnsuccessful()
	{
		long tktID = bk.reserve(pid.getPid(), crImpossible);
		assertTrue(tktID==-1);
	}
	
	public void testDoubleReservation()
	{
		long tktID1 = bk.reserve(pid.getPid(), crPossible);
		assertTrue(tktID1!=-1);
		long tktID2 = bk.reserve(pid.getPid(), crPossible);
		assertTrue(tktID2==-1);
	}

	public void testDoubleReservationWithLeaseExpiration()
	{
		long tktID1 = bk.reserve(pid.getPid(), crPossible);
		assertTrue(tktID1!=-1);
		Object lock = new Object();
		
		long time=System.currentTimeMillis();
		while(System.currentTimeMillis()<time+7000);
		
		long tktID2 = bk.reserve(pid.getPid(), crPossible);
		assertTrue(tktID2!=-1);
	}

	/*public void testSimpleTest()
	{
		assertEquals(3, (1+1));
	}*/
	/* (non-Javadoc)
	 * @see java.lang.Object#finalize()
	 */
}
