#include <jni.h>
#include "CpuApi.H"
#include "cpuJApi_CpuJApi.h"
#include <stdio.h>

CpuApi* cpu = NULL;


void jGetCpuReserve(JNIEnv *env, jobject jcr, CpuReserve* cr) {
    jclass cls = env->GetObjectClass(jcr);
    cr->serviceClass = env->GetIntField(jcr, env->GetFieldID(cls, "serviceClass", "I"));
    cr->period = env->GetLongField(jcr, env->GetFieldID(cls, "period", "J"));
    cr->peakProcessingTime = env->GetLongField(jcr, env->GetFieldID(cls, "peakProcessingTime", "J"));
    cr->sustainableProcessingTime = env->GetLongField(jcr, env->GetFieldID(cls, "sustainableProcessingTime", "J"));
    cr->burstTolerance = env->GetLongField(jcr, env->GetFieldID(cls, "burstTolerance", "J"));    
    cr->peakProcessingUtil = env->GetDoubleField(jcr, env->GetFieldID(cls, "peakProcessingUtil", "D"));
}


void jSetCpuReserve(JNIEnv *env, jobject jcr, CpuReserve* cr) {
    jclass cls = env->GetObjectClass(jcr);
    env->SetIntField(jcr, env->GetFieldID(cls, "serviceClass", "I"), cr->serviceClass);
    env->SetLongField(jcr, env->GetFieldID(cls, "period", "J"), cr->period);
    env->SetLongField(jcr, env->GetFieldID(cls, "peakProcessingTime", "J"), cr->peakProcessingTime);
    env->SetLongField(jcr, env->GetFieldID(cls, "sustainableProcessingTime", "J"), cr->sustainableProcessingTime);
    env->SetLongField(jcr, env->GetFieldID(cls, "burstTolerance", "J"), cr->burstTolerance);    
    env->SetDoubleField(jcr, env->GetFieldID(cls, "peakProcessingUtil", "D"), cr->peakProcessingUtil);
}



void jGetAdaptStrategy(JNIEnv *env, jobject obj, AdaptStrategy* as) {
    jclass cls = env->GetObjectClass(obj);
    as->strategy = env->GetIntField(obj, env->GetFieldID(cls, "strategy", "I"));
    as->windowSize = env->GetIntField(obj, env->GetFieldID(cls, "windowSize", "I"));
    as->alpha = env->GetDoubleField(obj, env->GetFieldID(cls, "alpha", "D"));
    as->max = env->GetDoubleField(obj, env->GetFieldID(cls, "max", "D"));
    as->min = env->GetDoubleField(obj, env->GetFieldID(cls, "min", "D"));    
    as->nonconformFreq = env->GetDoubleField(obj, env->GetFieldID(cls, "nonconformFreq", "D"));
}



void jSetAdaptStrategy(JNIEnv *env, jobject obj, AdaptStrategy* as) {
    jclass cls = env->GetObjectClass(obj);
    env->SetIntField(obj, env->GetFieldID(cls, "strategy", "I"), as->strategy);
    env->SetIntField(obj, env->GetFieldID(cls, "windowSize", "I"), as->windowSize);
    env->SetDoubleField(obj, env->GetFieldID(cls, "alpha", "D"), as->alpha);
    env->SetDoubleField(obj, env->GetFieldID(cls, "max", "D"), as->max);
    env->SetDoubleField(obj, env->GetFieldID(cls, "min", "D"), as->min);    
    env->SetDoubleField(obj, env->GetFieldID(cls, "nonconformFreq", "D"), as->nonconformFreq);
}


void jSetProc(JNIEnv *env, jobject jp, Process* p) {
    jclass cls = env->GetObjectClass(jp);
    env->SetIntField(jp, env->GetFieldID(cls, "idx", "I"), p->idx);
    env->SetIntField(jp, env->GetFieldID(cls, "pid", "I"), p->pid);
    env->SetIntField(jp, env->GetFieldID(cls, "euid", "I"), p->euid);
    env->SetIntField(jp, env->GetFieldID(cls, "egid", "I"), p->egid);
    env->SetIntField(jp, env->GetFieldID(cls, "state", "I"), p->state);
    env->SetIntField(jp, env->GetFieldID(cls, "prid", "I"), p->prid);
}


void jSetProcStats(JNIEnv *env, jobject jps, ProcStats* ps) {
    jclass cls = env->GetObjectClass(jps);
    env->SetLongField(jps, env->GetFieldID(cls, "clock", "J"), ps->clock);
    env->SetLongField(jps, env->GetFieldID(cls, "usage", "J"), ps->usage);
    env->SetBooleanField(jps, env->GetFieldID(cls, "nonconformFlag", "Z"), ps->nonconformFlag);
    env->SetBooleanField(jps, env->GetFieldID(cls, "overrunFlag", "Z"), ps->overrunFlag);
    env->SetLongField(jps, env->GetFieldID(cls, "apDeadline", "J"), ps->apDeadline);
    env->SetBooleanField(jps, env->GetFieldID(cls, "permNonconformFlag", "Z"), ps->permNonconformFlag);
    env->SetIntField(jps, env->GetFieldID(cls, "overrunItr", "I"), ps->overrunItr);
    env->SetLongField(jps, env->GetFieldID(cls, "accUsage", "J"), ps->accUsage);
    env->SetIntField(jps, env->GetFieldID(cls, "accNumNonconform", "I"), ps->accNumNonconform);
    env->SetIntField(jps, env->GetFieldID(cls, "accNumOverrun", "I"), ps->accNumOverrun);
    env->SetIntField(jps, env->GetFieldID(cls, "accNumPermNonconform", "I"), ps->accNumPermNonconform);
    env->SetIntField(jps, env->GetFieldID(cls, "accNumDeadlineMiss", "I"), ps->accNumDeadlineMiss);
    env->SetIntField(jps, env->GetFieldID(cls, "accItr", "I"), ps->accItr);
    
    /*
     jobject jcr = env->GetObjectField(jps, env->GetFieldID(cls, "cpuReserve", "CpuReserve"));
     printf("11----\n");
     jSetCpuReserve(env, jcr, &(ps->cpuReserve));
     printf("12----\n");
     jobject jas = env->GetObjectField(jps, env->GetFieldID(cls, "adaptStrategy", "L"));
     printf("13----\n");
     jSetAdaptStrategy(env, jas, &(ps->adaptStrategy));
     printf("14----\n");
   */
}


void jSetSchedStats(JNIEnv *env, jobject jss, SchedStats* ss) {
    jclass cls = env->GetObjectClass(jss);
    env->SetLongField(jss, env->GetFieldID(cls, "clock", "J"), ss->clock);
    env->SetIntField(jss, env->GetFieldID(cls, "numProcessor", "I"), ss->numProcessor);
    env->SetDoubleField(jss, env->GetFieldID(cls, "overrunRatio", "D"), ss->overrunRatio);
    env->SetDoubleField(jss, env->GetFieldID(cls, "permRatio", "D"), ss->permRatio);
    env->SetDoubleField(jss, env->GetFieldID(cls, "tsRatio", "D"), ss->tsRatio);
}


void jSetSchedStats(JNIEnv *env, jobject jpr, Processor* pr) {
    jclass cls = env->GetObjectClass(jpr);
    env->SetDoubleField(jpr, env->GetFieldID(cls, "availPermUtil", "D"), pr->availPermUtil);
    env->SetDoubleField(jpr, env->GetFieldID(cls, "overrunRatio", "D"), pr->overrunRatio);
    env->SetDoubleField(jpr, env->GetFieldID(cls, "permRatio", "D"), pr->permRatio);
    env->SetDoubleField(jpr, env->GetFieldID(cls, "tsRatio", "D"), pr->tsRatio);
    env->SetLongField(jpr, env->GetFieldID(cls, "permUsage", "J"), pr->permUsage);
    env->SetLongField(jpr, env->GetFieldID(cls, "burstUsage", "J"), pr->burstUsage);
    env->SetLongField(jpr, env->GetFieldID(cls, "nonconformUsage", "J"), pr->nonconformUsage);
    env->SetLongField(jpr, env->GetFieldID(cls, "probeUsage", "J"), pr->probeUsage);
    env->SetLongField(jpr, env->GetFieldID(cls, "tsUsage", "J"), pr->tsUsage);
}


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    init
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_init
  (JNIEnv *, jclass) {
    if (cpu)
	return(0);
    else {
	cpu = new CpuApi();  // contacting the CpuSvc
	return(1);
    }
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    reserve
 * Signature: (LCpuReserve;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_reserve
  (JNIEnv *env, jclass, jobject jcr, jint pid) {
    if (!cpu)
	return(0);
    CpuReserve cr;
    jGetCpuReserve(env, jcr, &cr);
    return(cpu->reserve(&cr, pid));
};


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    modify
 * Signature: (LCpuReserve;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_modify
  (JNIEnv *env, jclass, jobject jcr, jint pid) {
    if (!cpu)
	return(0);
    jclass cls = env->GetObjectClass(jcr);
    CpuReserve cr;
    jGetCpuReserve(env, jcr, &cr);
    return(cpu->modify(&cr, pid));
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    free
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_free
  (JNIEnv *, jclass, jint pid) {
    if (cpu) 
	return(cpu->free(pid));
    else
	return(0);
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    start
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_start
  (JNIEnv *, jclass, jint pid) {
    if (cpu) 
	return(cpu->start(TIMEVAL_ZERO, pid));
    else
	return(0);    
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    stop
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_stop
  (JNIEnv *, jclass, jint pid) {
    if (cpu) 
	return(cpu->stop(pid));
    else
	return(0);
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    destroy
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_destroy
  (JNIEnv *, jclass, jint) {
    if (cpu) {
	delete cpu;
	cpu = NULL;
	return(1);
    }
    else
	return(0);
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    yield
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_cpuJApi_CpuJApi_yield
  (JNIEnv *, jclass) {
    if (cpu)
	cpu->yield();
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    svcDestroy
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_cpuJApi_CpuJApi_svcDestroy
  (JNIEnv *, jclass) {
    if (cpu)
	cpu->destroy();
};


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    setAdaptStrategy
 * Signature: (LAdaptStrategy;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_setAdaptStrategy
  (JNIEnv *env, jclass, jobject obj, jint pid) {
    if (!cpu)
	return(0);
    AdaptStrategy as;
    jGetAdaptStrategy(env, obj, &as);
    return(cpu->setAdaptStrategy(&as, pid));
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    setApDeadline
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_setApDeadline
  (JNIEnv *, jclass, jlong deadline) {
    if (cpu)
	return(cpu->setApDeadline(deadline));
    else
	return(0);
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    probe
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_probe
  (JNIEnv *, jclass, jlong period) {
    if (cpu)
	return(cpu->probe(period));
    else
	return(0);
};
 
/*
 * Class:     cpuJApi_CpuJApi
 * Method:    probeEnd
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_probeEnd
  (JNIEnv *, jclass) {
    if (cpu)
	return(cpu->probeEnd());
    else
	return(0);
};



/*
 * Class:     cpuJApi_CpuJApi
 * Method:    probeMatch
 * Signature: (LCpuReserve;)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_probeMatch
  (JNIEnv *env, jclass, jobject jcr) {
    CpuReserve cr;
    if (cpu) {
	int res = cpu->probeMatch(&cr);
	if (res)
	    jSetCpuReserve(env, jcr, &cr);
	return(res);
    }
    return(0);
};



/*
 * Class:     cpuJApi_CpuJApi
 * Method:    setRecordProcStats
 * Signature: (Ljava/lang/String;)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_setRecordProcStats
  (JNIEnv *env , jclass, jstring fname) {
    if (!cpu)
	return(0);
    int res;
    if (fname == NULL)
	res = cpu->setRecordProcStats();
    else {
	const char *str = env->GetStringUTFChars(fname, 0);
	res = cpu->setRecordProcStats((char*)str);
	env->ReleaseStringUTFChars(fname, str);
    }
    return(res);
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    setRecordSchedStats
 * Signature: (Ljava/lang/String;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_setRecordSchedStats
  (JNIEnv *env, jclass, jstring fname, jlong samplingInterval) {
    if (!cpu)
	return(0);
    int res;
    if (fname == NULL) 
	res = cpu->setRecordSchedStats(NULL, samplingInterval);
    else {
	const char *str = env->GetStringUTFChars(fname, 0);
	res = cpu->setRecordSchedStats((char*)str, samplingInterval);
	env->ReleaseStringUTFChars(fname, str);
    }
    return(res);
};



/*
 * Class:     cpuJApi_CpuJApi
 * Method:    pgetProcStats
 * Signature: (LcpuJApi/ProcStats;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_pgetProcStats
  (JNIEnv *env, jclass, jobject jps, jlong pid) {
    ProcStats* ps;
    if (!cpu || 
	(ps = cpu->getProcStats(pid))==NULL)
	return(0);
    jSetProcStats(env, jps, ps);
    return(1);
};


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    _getSchedStats
 * Signature: (LcpuJApi/SchedStats;)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi__1getSchedStats__LcpuJApi_SchedStats_2
  (JNIEnv *env, jclass, jobject jss) {
    SchedStats* ss;
    if (!cpu || 
	(ss = cpu->getSchedStats())==NULL)
	return(0);
    jSetSchedStats(env, jss, ss);
    return(1);
};


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    _getSchedStats
 * Signature: (LcpuJApi/Processor;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi__1getSchedStats__LcpuJApi_Processor_2I
  (JNIEnv *env, jclass, jobject jpr, jint prid) {
    SchedStats* ss;
    if (!cpu || 
	(ss = cpu->getSchedStats())==NULL)
	return(0);
    jSetSchedStats(env, jpr, &(ss->processors[prid]));
};


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    isPermNonconform
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_isPermNonconform
  (JNIEnv *env, jclass, jint pid) {
    ProcStats* ps;
    if (!cpu || 
	(ps = cpu->getProcStats(pid))==NULL)
	return(0);
    else
	return(ps->permNonconformFlag);
};

/*
 * Class:     cpuJApi_CpuJApi
 * Method:    getPidTab
 * Signature: ([II)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi_getPidTab
  (JNIEnv *env, jclass, jintArray pidTab, jint len) {
    if (!cpu)
	return(0);
    jint* ibody = env->GetIntArrayElements(pidTab, 0);
    cpu->getPidTab((int*)ibody, (int)len);
    env->ReleaseIntArrayElements(pidTab, ibody, 0);
    return(1);
};


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    _getProcStats
 * Signature: (LcpuJApi/ProcStats;LcpuJApi/CpuReserve;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi__1getProcStats
  (JNIEnv *env, jclass, jobject jps, jobject jcr, jint pid) {
    ProcStats* ps;
    if (!cpu || 
	(ps = cpu->getProcStats(pid))==NULL)
	return(0);
    jSetProcStats(env, jps, ps);
    jSetCpuReserve(env, jcr, &(ps->cpuReserve));
    return(1);
};


/*
 * Class:     cpuJApi_CpuJApi
 * Method:    _getProc
 * Signature: (LcpuJApi/Proc;LcpuJApi/CpuReserve;LcpuJApi/AdaptStrategy;I)Z
 */
JNIEXPORT jboolean JNICALL Java_cpuJApi_CpuJApi__1getProc
  (JNIEnv *env, jclass, jobject jp, jobject jcr, jobject jas, jint pid) {
    Process* p;
    if (!cpu || 
	(p = cpu->getProcess(pid))==NULL)
	return(0);
    jSetProc(env, jp, p);
    jSetCpuReserve(env, jcr, &(p->cpuReserve));
    jSetAdaptStrategy(env, jas, &(p->adaptStrategy));
    return(1);
};
