package cpuJApi;

public class Proc {
    public int idx;
    public int pid;
    public int euid;
    public int egid;
    public int state;
    public int prid;
    public CpuReserve cpuReserve;
    public AdaptStrategy adaptStrategy;
    public ProcStats ps;

    public final static int PSTATE_INIT = 0;
    public final static int PSTATE_RESERVE = 1; 
    public final static int PSTATE_PROBE_INIT = 2; 
    public final static int PSTATE_RUN = 3;     
    public final static int PSTATE_WAIT = 4;    
    public final static int PSTATE_OVERRUN = 5; 
    public final static int PSTATE_SCHED = 6;
    public final static int PSTATE_PROBE = 7;   

    public Proc() {
	idx = -1;
	pid = 0;
	euid = 0;
	egid = 0;
	state = PSTATE_INIT;
	prid = -1;
	cpuReserve = new CpuReserve();
	adaptStrategy = new AdaptStrategy();
	ps = new ProcStats();
    }

    public String toString() {
	return(" idx:" + idx +
	       " pid:" + pid +
	       " euid:" + euid + 
	       " egid:" + egid + 
	       " state:" + stateToString() + 
	       " prid:" + prid +
	       " cpuReserve:" + cpuReserve +
	       " adapt:" + adaptStrategy.toString() +
	       " ps:" + ps.toString());
    }
    
    public String stateToString() {
	switch (state) {
	case PSTATE_INIT:
	    return("Init");
	case PSTATE_RESERVE:	
	    return("Reserve");
	case PSTATE_PROBE_INIT:	
	case PSTATE_PROBE:	
	    return("Probing");
	case PSTATE_RUN:	
	case PSTATE_WAIT: 
	case PSTATE_OVERRUN:	
	case PSTATE_SCHED:	
	    return("Run");
	default:
	    return("Error");
	}
    }
}
