package cpuJApi;

public class SchedStats
{
   
    public long clock;
    public int numProcessor;
    public Processor[] processors;
    public double overrunRatio;
    public double permRatio;
    public double tsRatio;

    public SchedStats() {
	clock = 0;
	numProcessor = 0;
	overrunRatio = 0;
	permRatio = 0;
	tsRatio = 0;
	processors = new Processor[CpuJApi.MAX_PROCESSOR];
	for (int i=0; i<CpuJApi.MAX_PROCESSOR; i++)
	    processors[i] = new Processor();
    }

    public double availPermUtil() {
	double availPermUtil = 0;
	for (int i=0; i<numProcessor; i++)
	    availPermUtil += processors[i].availPermUtil;
	return(availPermUtil);
    }

    public double permUsage() {
	double permUsage = 0;
	for (int i=0; i<numProcessor; i++)
	    permUsage += processors[i].permUsage;
	return(permUsage);
    }

    public double burstUsage() {
	double burstUsage = 0;
	for (int i=0; i<numProcessor; i++)
	    burstUsage += processors[i].burstUsage;
	return(burstUsage);
    }

    public double nonconformUsage() {
	double nonconformUsage = 0;
	for (int i=0; i<numProcessor; i++)
	    nonconformUsage += processors[i].nonconformUsage;
	return(nonconformUsage);
    }

    public double probeUsage() {
	double probeUsage = 0;
	for (int i=0; i<numProcessor; i++)
	    probeUsage += processors[i].probeUsage;
	return(probeUsage);
    }

    public double tsUsage() {
	double tsUsage = 0;
	for (int i=0; i<numProcessor; i++)
	    tsUsage += processors[i].tsUsage;
	return(tsUsage);
    }

};
