/*
 * Created on Mar 3, 2004
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package listEntities_test;

import org.omg.CORBA.ORBPackage.InvalidName;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.CosNaming.NamingContextPackage.CannotProceed;
import org.omg.CosNaming.NamingContextPackage.NotFound;

import MonitoredEntities.EntityRepository;
import MonitoredEntities.EntityRepositoryHelper;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ListEntities
{
	private static org.omg.CORBA.ORB orb;
	private static EntityRepository eREP;

	public static void main(String[] args)
	{
		orb  = org.omg.CORBA.ORB.init(args, null);
		
		try
		{
			// get reference to the initial naming context	    
			NamingContextExt nc;
			nc =NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));
			    
			// get reference to entities repository
			NameComponent [] name = new NameComponent[2];
			name[0] = new NameComponent("Adaptacao","context");
			name[1] = new NameComponent("EntityRepository","service");
			eREP = EntityRepositoryHelper.narrow(nc.resolve(name));
		}
		catch (InvalidName e)
		{
			e.printStackTrace();
		} catch (NotFound e)
		{
			e.printStackTrace();
		} catch (CannotProceed e)
		{
			e.printStackTrace();
		} catch (org.omg.CosNaming.NamingContextPackage.InvalidName e)
		{
			e.printStackTrace();
		}
		
		String [] hostList = eREP.list_me();
		
		for(int i=0; i<hostList.length; i++)
		{
			String address = new String("atp://").concat(hostList[i]).concat(":4434");
			System.out.println(address);	
		}
	}
}
