package loadtest;

import com.ibm.aglet.Aglet;
import com.ibm.aglet.event.MobilityAdapter;
import com.ibm.aglet.event.MobilityEvent;
import com.ibm.aglet.event.MobilityListener;

/*
 * Created on Jun 25, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class LoadTestAglet extends Aglet
{	
	LoadTestDialog dialog;
	String serverAddress;
	Integer qty;
	ReflectorClient rc;
	
	public void onCreation(Object init)
	{
		// Adds a mobility listener
		MobilityListener mobListen = new MobilityAdapter()
		{
			public void onDispatching(MobilityEvent event)
			{
				System.out.println("[DEBUG] Stopping threads before dispatch");
				stopClients();
			}
			
			public void onArrival(MobilityEvent event)
			{
				System.out.println("[DEBUG] Reflector has arrived");
				createClients();
			}
			
			public void onReverting(MobilityEvent event)
			{
				System.out.println("[DEBUG] Stopping threads before coming back");
				stopClients();
			}
		};
		
		addMobilityListener(mobListen);
		dialog = new LoadTestDialog();
		dialog.show();
		dialog.waitResults();
		
		this.qty=dialog.getQty();
		this.serverAddress=dialog.getServerAddress();
		
		System.out.println(this.qty.intValue());
		System.out.println(serverAddress);
		createClients();
	}
	
	public void createClients()
	{	
		rc=new ReflectorClient(this.serverAddress, this.qty);
	}
	
	public void startClients()
	{
		rc.start();
	}
	
	public void stopClients()
	{
		rc.stopReading();		
	}
	
	public void run()
	{
		startClients();
	}
	
	public void onDisposing()
	{
		System.out.println("[DEBUG] Disposing Aglet");
		stopClients();
	} 
}
