/*
 * Created on Jun 30, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package loadtest;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.Socket;
import java.net.URL;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorClient extends Thread implements Serializable
{
	transient private boolean keepReading;
	transient URL reflectorAddr;
	transient Socket [] reflectors;
	transient BufferedReader [] inputs;
	
	transient PrintWriter outputToServer;
		
	String serverAddress;
	Integer numOfClients;
	ReflectorClientDialog dialog;
	transient long bytesRead;
	
	public ReflectorClient(String serverAddress, Integer numOfClients)
	{
		this.keepReading=true;
		
		this.serverAddress=serverAddress;
		this.numOfClients=numOfClients;
		this.bytesRead=0;
		
		reflectors = new Socket[numOfClients.intValue()];
		inputs = new BufferedReader[numOfClients.intValue()];
	}
	
	public void run()
	{
		try
		{
			reflectorAddr = new URL(serverAddress);

			String host=reflectorAddr.getHost();
			int port=reflectorAddr.getPort();
			if(port==-1)
				port=80;

			System.out.println("[DEBUG] Addr -> "+host);
			System.out.println("[DEBUG] Port -> "+port);
			System.out.println("[DEBUG] File -> "+reflectorAddr.getFile());
							
			for(int i=0; i<this.numOfClients.intValue(); i++)
			{
				reflectors[i]=new Socket(host, port);
				inputs[i] = new BufferedReader(new InputStreamReader(reflectors[i].getInputStream()));
				outputToServer = new PrintWriter(reflectors[i].getOutputStream(), true);
				// Begins http connection
				System.out.println("GET "+reflectorAddr.getFile()+" HTTP/1.0\r \n");
				outputToServer.println("GET "+reflectorAddr.getFile()+" HTTP/1.0\r \n");				
			}
		} catch (MalformedURLException e)
		{
			e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	
		dialog=new ReflectorClientDialog(this.numOfClients);
		dialog.show();
		
		char[] inputChar = new char[1];
	
		try
		{
			while(keepReading)
			{
				for(int i=0; i<this.numOfClients.intValue(); i++)
				{
					if(inputs[i].read(inputChar)!=-1)
					{						
						bytesRead++;
						//System.out.println(bytesRead);
						dialog.setBytes(bytesRead);
					}
				}
			}
		} catch (IOException e1)
		{
			e1.printStackTrace();
		}
	}
	
	public void stopReading()
	{
		this.keepReading=false;
	}
}
