/*
 * Created on Jul 7, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package loadtest;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.Serializable;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorClientDialog implements Serializable
{
	transient JFrame mainWindow;
	transient JPanel dialogPanel;
	
	transient JLabel labelNoc;
	transient JTextField fieldNoc;
	transient JLabel labelBytes;
	transient JTextField fieldBytes;
	
	transient long bytes;
	transient Integer noc;
	
	public ReflectorClientDialog(Integer noc)
	{
		this.bytes=0;
		this.noc=noc;
		
		this.mainWindow=new JFrame("LoadTest progress");
		this.dialogPanel = new JPanel();
		dialogPanel.setLayout(new GridLayout(2,2));
		dialogPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		
		addWidgets();
		
		this.mainWindow.getContentPane().add(this.dialogPanel, BorderLayout.CENTER);	
		this.mainWindow.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}

	public void show()
	{
		this.mainWindow.pack();
		this.mainWindow.setVisible(true);	
	}

	/**
	 * 
	 */
	private void addWidgets()
	{
		this.fieldNoc = new JTextField(30);
		this.fieldBytes = new JTextField(30);
		this.labelNoc = new JLabel("Number of Clients:", SwingConstants.LEFT);
		this.labelBytes = new JLabel("Total bytes read:");
		JLabel empty = new JLabel();
		
		dialogPanel.add(this.labelNoc);
		dialogPanel.add(this.fieldNoc);
		dialogPanel.add(this.labelBytes);
		dialogPanel.add(this.fieldBytes);
		
		this.fieldNoc.setText(noc.toString());
		this.fieldBytes.setText(Long.toString(this.bytes));
	}

	
	/**
	 * @param l
	 */
	public void setBytes(long l)
	{
		bytes = l;
		this.fieldBytes.setText(Long.toString(bytes));
	}

}
