/*
 * Created on Dec 10, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package negotiator;

import java.io.IOException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Vector;

import org.omg.CORBA.ORB;
import org.omg.CosNaming.NamingContextExtHelper;

import reflector.Abductor;

import CORBAbroker.Broker;
import CORBAbroker.BrokerHelper;

import com.ibm.aglet.Aglet;
import com.ibm.aglet.AgletProxy;
import com.ibm.aglet.InvalidAgletException;
import com.ibm.aglet.Message;
import com.ibm.aglet.MessageException;
import com.ibm.aglet.NotHandledException;
import com.ibm.aglet.RequestRefusedException;
import com.ibm.aglet.event.MobilityAdapter;
import com.ibm.aglet.event.MobilityEvent;
import com.ibm.aglet.event.MobilityListener;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class NegotiationAgent extends Aglet
{
	Vector qosLevels;
	Integer requesterPid;
	AgletProxy father;
	Vector destinations;
	
	//String hostToVisit;
	URL hostToVisit;
	
	NegotiationResult result;
	boolean resultReady;
	
	Broker transport;
	Abductor a;
		
	/* (non-Javadoc)
	 * @see com.ibm.aglet.Aglet#onCreation(java.lang.Object)
	 */
	public void onCreation(Object init)
	{
		NegotiationAgentInit ref=(NegotiationAgentInit)init;
		this.qosLevels=ref.getQosLevels();
		this.requesterPid=ref.getRequesterPid();
		this.destinations=ref.getDestination();
		this.father=ref.getFather();
		resultReady=false;
		
		// Classes that must be transfered along with the aglet
		result = null;
		a = Abductor.instance();
		try
		{
			a.addObject(Class.forName("negotiator.NegotiationResult"));
		}
		catch (ClassNotFoundException e1)
		{
			e1.printStackTrace();
		}
		
		//new NegotiationResult();		
		
		// Adds a mobility listener
		MobilityListener mobListen = new MobilityAdapter()
		{
			public void onArrival(MobilityEvent event)
			{	
				// Negotiation
				long reservationTicket;
		
				Broker bk = getBrokerReference();
				
				boolean success=false;
				for(Enumeration e=qosLevels.elements(); e.hasMoreElements();)
				{
					String[] res=(String[])e.nextElement();
					System.out.println("Trying to reserve "+" "+res[0]+" "+res[1]+" "+res[2]+" "+res[3]+" "+res[4]);
					reservationTicket=bk.reserve(res, requesterPid.shortValue());
					if(reservationTicket!=-1)
					{
						 result=new NegotiationResult(reservationTicket, res, hostToVisit);
						 success=true;
						 System.out.println("Sucesso!!");
						 System.out.println(result.toString());
						 sendResult();
						 break;
					}
				}
		
				if(!success)
				{
					System.out.println("Fracasso...");
					String [] test=(String[])qosLevels.firstElement();
					System.out.println("Teste "+test[0]+test[1]+test[2]+test[3]+test[4]);
					String [] sug=bk.suggest(test);
					System.out.println("Sugesto "+sug[0]+sug[1]+sug[2]+sug[3]+sug[4]);
								
					 // Try to use suggestion
					reservationTicket=bk.reserve(sug, requesterPid.shortValue());
					if(reservationTicket!=-1)
					{
						result=new NegotiationResult(reservationTicket, sug, hostToVisit);
						success=true;
						System.out.println("Sucesso na repescagem!");
						System.out.println(result.toString());
						sendResult();
					}
					else
					{
						System.out.println("Fracasso novamente...");
						result=new NegotiationResult(-1, null, hostToVisit);
						sendResult();
					}
				}				
			}
		};
		
		addMobilityListener(mobListen);
	}	
	
	/* (non-Javadoc)
	 * @see com.ibm.aglet.Aglet#run()
	 */
	public void run()
	{
		if(destinations.isEmpty())
		{
			System.out.println("[NEGOTIATION AGENT] Disposing...");
			dispose(); 
		} 
	
		hostToVisit = (URL)destinations.firstElement();
		destinations.remove(0);
		System.out.println("[NEGOTIATION AGENT] Going to host "+hostToVisit.toString());
				
		// Go to host
		try
		{
			dispatch(hostToVisit);
		} catch (RequestRefusedException e1)
		{
			e1.printStackTrace();
			sendResult();
			dispose();
		} catch (IOException e1)
		{
			e1.printStackTrace();
		}
	}
	
	private void sendResult()
	{
		System.out.println("[NEGOTIATION AGENT] Sending result...");
		
		try
		{
			father.sendMessage(new Message("result", result));
		} catch (InvalidAgletException e1)
		{
			e1.printStackTrace();
		} catch (NotHandledException e1)
		{
			e1.printStackTrace();
		} catch (MessageException e1)
		{
			e1.printStackTrace();
		}
	}
	
	
		
	/**
	 * @return
	 */
	private Broker getBrokerReference()
	{
		String args[]=null;
		ORB orb  = org.omg.CORBA.ORB.init(args, null);
						
		try
		{
			org.omg.CosNaming.NamingContextExt nc =
							org.omg.CosNaming.NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));
						
			nc = NamingContextExtHelper.narrow(nc.resolve(nc.to_name("DSRT_Broker")));
			System.out.println("Servidor que est sendo visitado  "+this.hostToVisit);
			Broker bk =BrokerHelper.narrow(nc.resolve(nc.to_name(this.hostToVisit.getHost())));					    
			//Broker bk =BrokerHelper.narrow(nc.resolve(nc.to_name("DSRT_Broker")));
			
			/*NameComponent [] name = new NameComponent[2];
		    name[0] = new NameComponent(nc.to_name("DSRT_Broker"));
		    name[1] = new NameComponent(this.hostToVisit, "");
		    System.out.println ("obtaining reference to entities repository");	    
			Broker bk =BrokerHelper.narrow(nc.resolve(name));*/
		    
		    System.out.println ("reference to entities repository obtained: OK...");  
			
			return bk; 
		} 
		catch (Exception e) 
		{
			e.printStackTrace();
		}
		return null;
	}
}

