 /*
 * Created on Dec 15, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package negotiator;

import java.io.Serializable;
import java.net.URL;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class NegotiationResult implements Serializable
{
	private String [] reservation;
	private long ticket;
	private URL host;
	
	public NegotiationResult(long tkt, String[] res, URL h)
	{
		this.ticket=tkt;
		this.host=h;
		this.reservation=res;
	}
	
	public NegotiationResult()
	{
		this.ticket=0;
		this.host=null;
		this.reservation=null;
	}
	
	
	/**
	 * @return
	 */
	public URL getHost()
	{
		return host;
	}

	/**
	 * @return
	 */
	public long getTicket()
	{
		return ticket;
	}

	/**
	 * @return
	 */
	public String[] getReservation()
	{
		return reservation;
	}
	
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		String output;
		
		if(this.ticket!=-1)
		{
			output=new String("Ticket ");
			output=output.concat(Long.toString(this.ticket));
			output=output.concat(" of reservation [");
			for(int i=0; i<this.reservation.length;i++)
				output=output.concat(this.reservation[i]+" ");
			output=output.concat("] at host ");
			output=output.concat(this.host.toString());
		}
		else
			output=new String("Invalid Ticket!");
		
		return(output);	
	}
}
