/*
 * Created on Dec 10, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package negotiator;

import java.io.Serializable;
import java.net.URL;

import com.ibm.aglet.AgletProxy;

import reflector.RoamingStrategy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class NegotiatorInit implements Serializable
{
	private URL fileName;
	private int pid;
	private int roamingStrategy;
	private AgletProxy application;
	
	/**
	 * @param string
	 * @param i
	 */
	public NegotiatorInit(URL url, int i, AgletProxy ap)
	{
		this.fileName=url;
		this.pid=i;
		roamingStrategy = RoamingStrategy.PARALLEL_ROAMING;
		this.application = ap;		
	}
	
	public NegotiatorInit(URL url, int i, int rs, AgletProxy ap)
	{
		this.fileName=url;
		this.pid=i;
		roamingStrategy = rs;		
		this.application = ap;
	}
	
	public NegotiatorInit()
	{}
	
	/**
	 * @return
	 */
	public URL getFileName()
	{
		return fileName;
	}

	/**
	 * @return
	 */
	public int getPid()
	{
		return pid;
	}

	/**
	 * @param string
	 */
	public void setFileName(URL url)
	{
		fileName = url;
	}

	/**
	 * @param integer
	 */
	public void setPid(int integer)
	{
		pid = integer;
	}

	/**
	 * @return
	 */
	public int getRoamingStrategy()
	{
		return roamingStrategy;
	}

	/**
	 * @param i
	 */
	public void setRoamingStrategy(int i)
	{
		roamingStrategy = i;
	}

	/**
	 * @return
	 */
	public AgletProxy getApplication()
	{
		return application;
	}

}
