/*
 * Created on May 7, 2004
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.io.Serializable;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.Vector;

/**
 * @author Roberto S. Cardoso
 *
 * Class responsible for keeping a reference to all migrated classes
 */
public class Abductor implements Serializable
{
	private static Abductor singleInstance = null;
	private Vector objects;
	
	private Abductor()
	{
		objects = new Vector();	
	}
	
	public static Abductor instance()
	{
		if(singleInstance==null)
			singleInstance = new Abductor();
			
		return(singleInstance);
	}
	
	public void addObject(Class c)
	{
		Class [] param = new Class[0];
		Constructor cons;
		
		try
		{
			cons = c.getConstructor(param);
			objects.add(cons.newInstance(new Object[0]));
		} catch (SecurityException e)
		{
			e.printStackTrace();
		} catch (NoSuchMethodException e)
		{
			e.printStackTrace();
		}
		catch (IllegalArgumentException e1)
		{
			e1.printStackTrace();
		}
		catch (InstantiationException e1)
		{
			e1.printStackTrace();
		} catch (IllegalAccessException e1)
		{
			e1.printStackTrace();
		} catch (InvocationTargetException e1)
		{
			e1.printStackTrace();
		}
	}
}
