/*
 * Created on Jul 7, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.Serializable;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class BandwidthDialog extends Thread implements Serializable
{
	transient JFrame mainWindow;
	transient JPanel dialogPanel;
	
	transient JLabel labelAvgBps;
	transient JTextField avgBps;
	transient JLabel labelCurBps;
	transient JTextField curBps;
	
	transient boolean outputIsOpen;
	
	transient CountingPrintWriter output;	
	
	public BandwidthDialog(CountingPrintWriter out)
	{	
		this.output = out;
		this.outputIsOpen = true;
		
		this.mainWindow=new JFrame("Enter the streaming server's address");
		this.dialogPanel = new JPanel();
		dialogPanel.setLayout(new GridLayout(2,2));
		dialogPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		
		addWidgets();
		
		this.mainWindow.getContentPane().add(this.dialogPanel, BorderLayout.CENTER);	
		this.mainWindow.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}
	
	public BandwidthDialog()
	{}

	private void show()
	{
		this.mainWindow.pack();
		this.mainWindow.setVisible(true);	
	}

	/**
	 * 
	 */
	private void addWidgets()
	{
		avgBps = new JTextField(10);
		curBps = new JTextField(10);
		labelAvgBps = new JLabel("Average Bandwidth (bps):", SwingConstants.LEFT);
		labelCurBps = new JLabel("Current Bandwidth (bps):");
		JLabel empty = new JLabel();
		
		dialogPanel.add(this.labelAvgBps);
		dialogPanel.add(this.labelCurBps);
		dialogPanel.add(this.avgBps);
		dialogPanel.add(this.curBps);
	}
	
	private void updateData()
	{
		avgBps.setText(Double.toString(output.getAverageBandwidth()));
		curBps.setText(Double.toString(output.getCurrentBandwidth()));
	}
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run()
	{
		show();
		while(outputIsOpen)
		{
			try
			{
				sleep(1000);
			} catch (InterruptedException e)
			{
				e.printStackTrace();
			}
			
			updateData();
		}
	}

	public void stopDlg()
	{
		this.outputIsOpen=false;
	}

}
