/*
 * Created on Jul 7, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class MixerAgletDialog implements ActionListener, Serializable
{
	transient JFrame mainWindow;
	transient JPanel dialogPanel;
	transient JButton ok;
	transient JButton cancel;
	
	transient JLabel labelAddr1;
	transient JTextField address1;
	transient JLabel labelAddr2;
	transient JTextField address2;
	transient JLabel labelPort;
	transient JTextField port;
	
	Boolean hasAddress;
	String server1Address;
	String server2Address;
	Integer localPort;
	
	public MixerAgletDialog()
	{
		this.server1Address=null;
		this.server2Address=null;
		hasAddress=new Boolean(false);
		
		this.mainWindow=new JFrame("Enter the streamings' addresses");
		this.dialogPanel = new JPanel();
		dialogPanel.setLayout(new GridLayout(3,3));
		dialogPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		
		addWidgets();
		
		this.mainWindow.getContentPane().add(this.dialogPanel, BorderLayout.CENTER);	
		this.mainWindow.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}

	public void show()
	{
		this.mainWindow.pack();
		this.mainWindow.setVisible(true);	
	}

	/**
	 * 
	 */
	private void addWidgets()
	{
		address1 = new JTextField(30);
		address2 = new JTextField(30);
		port = new JTextField(30);
		labelAddr1 = new JLabel("First Streaming Address:", SwingConstants.LEFT);
		labelAddr2 = new JLabel("Second Streaming Address:", SwingConstants.LEFT);
		labelPort = new JLabel("Local Output Port:");
		JLabel empty = new JLabel();
		ok = new JButton("OK");
		cancel = new JButton("Cancel");
		
		ok.addActionListener(this);
		
		dialogPanel.add(this.labelAddr1);
		dialogPanel.add(this.labelAddr2);
		dialogPanel.add(this.labelPort);
		dialogPanel.add(this.address1);
		dialogPanel.add(this.address2);
		dialogPanel.add(this.port);
		dialogPanel.add(this.ok);
		dialogPanel.add(this.cancel);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public synchronized void actionPerformed(ActionEvent e)
	{
		System.out.println("[DIALOG]"+address1.getText());
		System.out.println("[DIALOG]"+address2.getText());
		setServer1Address(this.address1.getText());
		setServer2Address(this.address2.getText());
		setLocalPort(new Integer(this.port.getText()));
		try
		{
			URL url= new URL(server1Address);
			url= new URL(server2Address);
		} catch (MalformedURLException e1)
		{
			//TODO: Implement better error handling when user mistypes streaming server's URL
			System.out.println("Incorrect address");
			return;
		}
		
		this.mainWindow.dispose();
		hasAddress=new Boolean(true);
		notify();
	}

	public synchronized void waitResults()
	{
		while(!this.hasAddress.booleanValue())
		{
			try
			{
				wait();
			} catch (InterruptedException e)
			{
				e.printStackTrace();
			}
		}
	}

	/**
	 * @return
	 */
	public Integer getLocalPort()
	{
		return localPort;
	}

	/**
	 * @param integer
	 */
	public void setLocalPort(Integer integer)
	{
		localPort = integer;
	}

	/**
	 * @return
	 */
	public String getServer1Address()
	{
		return server1Address;
	}

	/**
	 * @return
	 */
	public String getServer2Address()
	{
		return server2Address;
	}

	/**
	 * @param string
	 */
	public void setServer1Address(String string)
	{
		server1Address = string;
	}

	/**
	 * @param string
	 */
	public void setServer2Address(String string)
	{
		server2Address = string;
	}

}
