/*
 * Created on Jul 7, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorAgletDialog implements ActionListener, Serializable
{
	transient JFrame mainWindow;
	transient JPanel dialogPanel;
	transient JButton ok;
	transient JButton cancel;
	
	transient JLabel labelAddr;
	transient JTextField address;
	transient JLabel labelPort;
	transient JTextField port;
	
	Boolean hasAddress;
	String serverAddress;
	Integer localPort;
	
	public ReflectorAgletDialog()
	{
		this.serverAddress=null;
		hasAddress=new Boolean(false);
		
		this.mainWindow=new JFrame("Enter the streaming server's address");
		this.dialogPanel = new JPanel();
		dialogPanel.setLayout(new GridLayout(3,3));
		dialogPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		
		addWidgets();
		
		this.mainWindow.getContentPane().add(this.dialogPanel, BorderLayout.CENTER);	
		this.mainWindow.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}

	public void show()
	{
		this.mainWindow.pack();
		this.mainWindow.setVisible(true);	
	}

	/**
	 * 
	 */
	private void addWidgets()
	{
		address = new JTextField(30);
		port = new JTextField(30);
		labelAddr = new JLabel("Streaming Server's Address:", SwingConstants.LEFT);
		labelPort = new JLabel("Local Output Port:");
		JLabel empty = new JLabel();
		ok = new JButton("OK");
		cancel = new JButton("Cancel");
		
		// To make it easy to test, server's address and port number are preloaded
		address.setText("http://durden:8000/mp3");
		port.setText("5567");
		
		ok.addActionListener(this);
		
		dialogPanel.add(this.labelAddr);
		dialogPanel.add(this.labelPort);
		dialogPanel.add(this.address);
		dialogPanel.add(this.port);
		dialogPanel.add(this.ok);
		dialogPanel.add(this.cancel);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public synchronized void actionPerformed(ActionEvent e)
	{
		System.out.println("[DIALOG]"+address.getText());
		setServerAddress(this.address.getText());
		setLocalPort(new Integer(this.port.getText()));
		try
		{
			URL url= new URL(serverAddress);
		} catch (MalformedURLException e1)
		{
			//TODO: Implement better error handling when user mistypes streaming server's URL
			System.out.println("Incorrect address");
			return;
		}
		
		this.mainWindow.dispose();
		hasAddress=new Boolean(true);
		notify();
	}

	public synchronized void waitResults()
	{
		while(!this.hasAddress.booleanValue())
		{
			try
			{
				wait();
			} catch (InterruptedException e)
			{
				e.printStackTrace();
			}
		}
	}

	/**
	 * @return
	 */
	public String getServerAddress()
	{
		return serverAddress;
	}

	/**
	 * @param string
	 */
	public void setServerAddress(String string)
	{
		serverAddress = string;
	}

	/**
	 * @return
	 */
	public Integer getLocalPort()
	{
		return localPort;
	}

	/**
	 * @param integer
	 */
	public void setLocalPort(Integer integer)
	{
		localPort = integer;
	}

}
