/*
 * Created on Aug 18, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.omg.CORBA.Any;
import org.omg.CosEventChannelAdmin.ConsumerAdmin;
import org.omg.CosEventChannelAdmin.EventChannel;
import org.omg.CosEventChannelAdmin.EventChannelHelper;
import org.omg.CosEventChannelAdmin.ProxyPullSupplier;
import org.omg.CosEventComm.Disconnected;
import org.omg.CosEventComm.PullConsumer;
import org.omg.CosEventComm.PullConsumerOperations;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;

import EventEvaluator.EventNotification;
import EventEvaluator.EventNotificationHelper;

import com.ibm.aglet.Aglet;
import com.ibm.aglet.AgletProxy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorConfigurator extends Thread implements Serializable, PullConsumerOperations
{
	static org.omg.CORBA.ORB orb;
	String args[];
	AgletProxy reflectorProxy;
	transient Method callback;
	transient Aglet reflector;

	/**
	 * 
	 */
	/*public ReflectorConfigurator(AgletProxy rp)
	{
		this.reflectorProxy = rp;
	}*/
	
	public ReflectorConfigurator(Aglet ra, Method cb)
	{
		this.callback=cb;
		this.reflector=ra;
	}
	
	public void run()
	{
		orb  = org.omg.CORBA.ORB.init(args, null);
		
		EventChannel  ecs = null;
		ConsumerAdmin ca;
		PullConsumer  pullConsumer = null;
		ProxyPullSupplier pps;

		try {
			NamingContextExt nc = NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));		    
			ecs = EventChannelHelper.narrow(nc.resolve(nc.to_name("eventchannel.resource")));
		} 
		catch (Exception e) 
		{
			e.printStackTrace();
		}

		ca  = ecs.for_consumers();
		pps = ca.obtain_pull_supplier();
		
		checkEvent(pps);
		
		try
		{
			callback.invoke(reflector, null);
		} catch (IllegalArgumentException e1)
		{
			e1.printStackTrace();
		} catch (IllegalAccessException e1)
		{
			e1.printStackTrace();
		} catch (InvocationTargetException e1)
		{
			e1.printStackTrace();
		}		
	}

	/**
	 * @param pps
	 */
	private void checkEvent(ProxyPullSupplier pps)
	{
		Any ev = null;
		EventNotification event;
		
		try
		{
			do
			{
				System.out.println("[DEBUG] Waiting for event");
				ev = pps.pull();
				event = EventNotificationHelper.extract(ev);
			}while(!event.eid.equalsIgnoreCase("CPU_HIGH"));
			
			System.out.println("[DEBUG] Event CPU_HIGH detected by the Aglet");
			System.out.println("[MESTRADO] tempo inicio "+System.currentTimeMillis());
		}
		catch (Disconnected e)
		{
			e.printStackTrace();
		}
	}


	/* (non-Javadoc)
	 * @see org.omg.CosEventComm.PullConsumerOperations#disconnect_pull_consumer()
	 */
	public void disconnect_pull_consumer()
	{
		System.out.println("[DEBUG] Consumer disconnected");		
	}
}
