/*
 * Created on Sep 1, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import org.omg.CORBA.Any;
import org.omg.CORBA.ORB;
import org.omg.CosEventChannelAdmin.ConsumerAdmin;
import org.omg.CosEventChannelAdmin.EventChannel;
import org.omg.CosEventChannelAdmin.EventChannelHelper;
import org.omg.CosEventChannelAdmin.ProxyPullSupplier;
import org.omg.CosEventComm.Disconnected;
import org.omg.CosEventComm.PullConsumer;
import org.omg.CosEventComm.PullConsumerOperations;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorConfiguratorMain implements PullConsumerOperations
{

	private static ORB orb;

	/* (non-Javadoc)
	 * @see org.omg.CosEventComm.PullConsumerOperations#disconnect_pull_consumer()
	 */
	public void disconnect_pull_consumer()
	{
		System.out.println("Foi desconectado!!");
	}

	public static void main(String[] args)
	{
		orb  = org.omg.CORBA.ORB.init(args, null);
		
		EventChannel  ecs = null;
		ConsumerAdmin ca;
		PullConsumer  pullConsumer = null;
		ProxyPullSupplier pps;

		try {
			NamingContextExt nc = NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));		    
			ecs = EventChannelHelper.narrow(nc.resolve(nc.to_name("eventchannel.resource")));
		} 
		catch (Exception e) 
		{
			System.out.println("[RECONFIGURATION] Couldn't resolve initial references");
			e.printStackTrace();
		}

		ca  = ecs.for_consumers();
		pps = ca.obtain_pull_supplier();

		Any ev = null;
		try
		{
			System.out.println("[RECONFIGURATION] Waiting for event CPU_HIGH");
			ev = pps.pull();
			System.out.println("[RECONFIGURATION] Event CPU_HIGH arrived! Starting reconfiguration");
		} catch (Disconnected e1)
		{
		 	System.out.println("[RECONFIGURATION] Event channel disconnected");
			e1.printStackTrace();
		}
		System.out.println(ev);
	}
}
