/*
 * Created on Jun 30, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.Socket;
import java.net.URL;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorConnectionHandler extends Thread implements Serializable
{
	transient private boolean keepSending;
	transient Socket connection;
	transient URL streamingServerAddr;
	transient Socket streamingServer;
	transient BufferedReader input;
	
	transient PrintWriter outputToServer;
	
	CountingPrintWriter codeWriter;
	transient CountingPrintWriter outputToClient;
	
	BandwidthDialog codeDialog;
	transient BandwidthDialog dlg;
	
	String serverAddress;
	
	public ReflectorConnectionHandler(String serverAddress, Socket connection)
	{
		this.connection=connection;
		this.keepSending=true;
		
		this.serverAddress=serverAddress;
		this.codeDialog = new BandwidthDialog(null);
		this.codeWriter = new CountingPrintWriter(null);
	}
	
	public ReflectorConnectionHandler()
	{}
	
	public void run()
	{
		try
		{
			streamingServerAddr = new URL(serverAddress);

			String host=streamingServerAddr.getHost();
			int port=streamingServerAddr.getPort();
			if(port==-1)
				port=80;

			System.out.println("[DEBUG] Addr -> "+host);
			System.out.println("[DEBUG] Port -> "+port);
			System.out.println("[DEBUG] File -> "+streamingServerAddr.getFile());
							
			streamingServer=new Socket(host, port);
			
			outputToClient = new CountingPrintWriter(new PrintWriter(connection.getOutputStream(), true));
			input = new BufferedReader(new InputStreamReader(streamingServer.getInputStream()));
			outputToServer = new PrintWriter(streamingServer.getOutputStream(), true);
			
			// Begins http connection
			System.out.println("GET "+streamingServerAddr.getFile()+" HTTP/1.0\r \n");
			outputToServer.println("GET "+streamingServerAddr.getFile()+" HTTP/1.0\r \n");
		} catch (MalformedURLException e)
		{
			e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	
		char[] inputChar = new char[1];
	
		// Shows the dialog with bandwidth statistics
		//dlg = new BandwidthDialog(outputToClient);
		//dlg.start();
	
		try
		{
			while(input.read(inputChar)!=-1 && keepSending)
			{
				outputToClient.print(inputChar);
				//System.out.print(inputChar);
			}
		} catch (IOException e1)
		{
			e1.printStackTrace();
		}
		
		try
		{
			connection.close();
		} catch (IOException e2)
		{
			e2.printStackTrace();
		}
	}
	
	public void stopSending()
	{
		this.keepSending=false;
		dlg.stopDlg();
	}
	
}
