/*
 * Created on Jan 12, 2004
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.CosNaming.NamingContextPackage.CannotProceed;
import org.omg.CosNaming.NamingContextPackage.InvalidName;
import org.omg.CosNaming.NamingContextPackage.NotFound;

import MonitoredEntities.EntityRepository;
import MonitoredEntities.EntityRepositoryHelper;

import com.ibm.aglet.AgletProxy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
//public abstract class RoamingStrategy implements Serializable
public class RoamingStrategy implements Serializable
{
	protected Vector hostsToVisit;
	protected Integer requesterPid;
	protected Vector reservations;
	protected AgletProxy negProxy;
	int numberOfReplies;
	
	private static org.omg.CORBA.ORB orb;
	private static EntityRepository eREP;
	
	//	Roaming Strategies
	public static final int PARALLEL_ROAMING=1;
	public static final int LINEAR_ROAMING=2;
	// protected static final int PEER2PEER_ROAMING=3;
	
	public RoamingStrategy(Vector reservs, Integer reqPid, AgletProxy negPx)
	{
		reservations=reservs;
		negProxy=negPx;
		requesterPid=reqPid;
		hostsToVisit = new Vector();
		defineHosts();
	}
	
	public RoamingStrategy()
	{}
	
	private void defineHosts()
	{
		String args[] = null;
		orb  = org.omg.CORBA.ORB.init(args, null);
		
		try
		{
			// get reference to the initial naming context	    
			NamingContextExt nc;
			nc =NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));
	    
			// get reference to entities repository
			NameComponent [] name = new NameComponent[2];
			name[0] = new NameComponent("Adaptacao","context");
			name[1] = new NameComponent("EntityRepository","service");
			eREP = EntityRepositoryHelper.narrow(nc.resolve(name));
		}
		catch (InvalidName e)
		{
			e.printStackTrace();
		} catch (NotFound e)
		{
			e.printStackTrace();
		} catch (CannotProceed e)
		{
			e.printStackTrace();
		} catch (org.omg.CORBA.ORBPackage.InvalidName e)
		{
			e.printStackTrace();
		} 

		String [] hostList = eREP.list_me();
						
		for(int i=0; i<hostList.length; i++)
		{
			//String address = new String("atp://").concat(hostList[i]).concat(":4434");
			URL address = null;
			if(!hostList[i].equals("durden"))
			{
				try
				{
					address = new URL("atp", hostList[i], 4434, "");
				} catch (MalformedURLException e1)
				{
					e1.printStackTrace();
				}
				System.out.println("[ROAMING STRATEGY] Added address "+address.toString());
				hostsToVisit.add(address);
			}
		}
		
		numberOfReplies = hostsToVisit.size();
	}

	//public abstract Vector definePath();
	public Vector definePath()
	{return null;}
	/**
	 * @return
	 */
	public int getNumberOfReplies()
	{
		return numberOfReplies;
	}

}
