package repClient;

import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;

import EventEvaluator.Interaction.InteractionEventRepository;
import EventEvaluator.Interaction.InteractionEventRepositoryHelper;
import EventEvaluator.Resource.ResourceEventRepository;
import EventEvaluator.Resource.ResourceEventRepositoryHelper;
import MonitoredEntities.EntityRepository;
import MonitoredEntities.EntityRepositoryHelper;

public class Client {
  
    private static Utilities.Console cs;
    private static EntityRepository eREP;
    private static ResourceEventRepository reREP;
    private static InteractionEventRepository ieREP;
    private static org.omg.CORBA.ORB orb;

    private static void inicializa() {
	try {
	    // get reference to the initial naming context	    
	    NamingContextExt nc = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService")); 
	    
	    // get reference to entities repository
	    NameComponent [] name = new NameComponent[2];
	    name[0] = new NameComponent("Adaptacao","context");
	    name[1] = new NameComponent("EntityRepository","service");
	    eREP = 
		EntityRepositoryHelper.narrow(nc.resolve(name));
	    
	    // get reference to ResourceEvent objects repository
	    NameComponent [] name2 = new NameComponent[2];
	    name2[0] = new NameComponent("Adaptacao","context");
	    name2[1] = new NameComponent("ResourceEventRepository","service");  
	    reREP = 
		ResourceEventRepositoryHelper.narrow(nc.resolve(name2));

	    // get reference to InteractionEvent objects repository
	    NameComponent [] name3 = new NameComponent[2];
	    name3[0] = new NameComponent("Adaptacao","context");
	    name3[1] = new NameComponent("InteractionEventRepository","service");  
	    ieREP = 
		InteractionEventRepositoryHelper.narrow(nc.resolve(name3));
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.out.println("givin up...");
	}
    }

    public static void main(String[] args) {
	cs = new Utilities.Console();

	// initialize 
	orb  = org.omg.CORBA.ORB.init(args, null);
	inicializa();
	EntityTypeClient etClient = new EntityTypeClient(cs, eREP);
	EntityClient eClient = new EntityClient(cs, eREP);
	ParameterClient pClient = new ParameterClient(cs, eREP);
	ResourceEventClient reClient = new ResourceEventClient(cs, reREP, eREP);
	InteractionEventClient ieClient = new InteractionEventClient(cs, ieREP);

	while (true) {
	    System.out.println("--------------------------------");
	    System.out.println("1..Add");
	    System.out.println("2..Delete");
	    System.out.println("3..List");
	    System.out.println("4..Quit");
	    System.out.println("--------------------------------");
	    int op1 = cs.readInt("your choice: ");
		    
	    if (op1==4) {
	    System.out.println("Bye...");
	    System.exit(1);
	    }
	    
	    System.out.println("--------------------------------");
	    System.out.println("1..Entity Type");
	    System.out.println("2..Entity");
	    System.out.println("3..Parameter");
	    System.out.println("4..Resource Event");
	    System.out.println("5..Interaction Event");
	    System.out.println("6..Return");
	    System.out.println("--------------------------------");
	    int op2 = cs.readInt("your choice: ");
	    
	    switch (op1) {
	    case 1: 
		switch (op2) {
		case 1:
		    etClient.add();
		    break;
		case 2:
		    eClient.add();
		    break;
		case 3:
		    pClient.add(); 
		    break;
		case 4:
		    reClient.add();
		    break;
		case 5:
		    ieClient.add();
		    break;
		case 6:
		    break;
		}
		break;
	    case 2:
		switch (op2) {
		case 1:
		    etClient.delete();
		    break;
		case 2:
		    eClient.delete();
		    break;
		case 3:
		    pClient.delete();
		    break;
		case 4:
		    reClient.delete();
		    break;
		case 5:
		    ieClient.delete();
		    break;
		case 6:
		    break;
		}
		break;
	    case 3:
		switch (op2) {
		case 1:
		    etClient.list();
		    break;
		case 2:
		    eClient.list();
		    break;
		case 3:
		    pClient.list();
		    break;
		case 4:
		    reClient.list();
		    break;
		case 5:
		    ieClient.list();
		    break;
		case 6:
		    break;
		}
		break;
	    }
	}
    }
}

