package repClient;

import java.util.Enumeration;
import java.util.Vector;

import MonitoredEntities.Entity;
import MonitoredEntities.EntityAlreadyExist;
import MonitoredEntities.EntityRepository;
import MonitoredEntities.EntityType;
import MonitoredEntities.NoSuchEntity;
import MonitoredEntities.NoSuchEntityType;

public class EntityClient {

  private Utilities.Console cs;
  private EntityRepository eREP;

  public EntityClient(Utilities.Console cs, EntityRepository eREP) {
    this.cs = cs;
    this.eREP = eREP;
  }
  
    public void add(){
	String meid = cs.readString("meid: ");
	String description = cs.readString("description: ");
	String metid = cs.readString("metid: ");
	try {
	    EntityType et = eREP.get_metype_ref(metid);
	    System.out.println("Add attribute list. Enter 'done' when finished.");
	    Vector vattr = new Vector();
	    boolean out = false;
	    do {
		String sattr = cs.readString("-->");
		if (sattr.equals("done"))
		    out = true;
		else
		    vattr.add(sattr);
	    } while(out==false);
	    String[] attr = new String[vattr.size()];
	    int i=0;
	    for (Enumeration e = vattr.elements() ; e.hasMoreElements() ;) {
		attr[i] = (String)e.nextElement();
		i++;
	    }
	    eREP.add_me(meid, et, description, attr);
	    System.out.println("added entity "+meid+" !");
	}
	catch (NoSuchEntityType nset) {
	  System.out.println("entity type"+metid+" does not exist !");
	}
	catch (EntityAlreadyExist eae) {
	  System.out.println("entity "+meid+" already exist !");
	}
    }
    
    public void delete(){
      String meid = cs.readString("meid: ");
	try {
	  eREP.erase_me(meid);
	  System.out.println("entity "+meid+" deleted !");
	}
	catch (NoSuchEntity nse) {
	  System.out.println("entity "+meid+" does not exist !");
	}
    }

    public void list(){
      String meid = cs.readString("meid: ");
	try {
	  Entity e = eREP.get_me_ref(meid);
	  System.out.println(e.meid());
	  System.out.println(e.description());
	  EntityType et = e.metype();
	  System.out.println(et.metid());
	  int nattr = e.num_attributes();
	  String[] attr = new String[nattr];
	  attr = e.attributes();

	  System.out.println("Attribute list:");
	  for (int i = 0; i < nattr; i++)
	      System.out.println("   "+attr[i]);
	}
	catch (NoSuchEntity nse) {
	  System.out.println("entity "+meid+" does not exist !");
	}
    }
}
