package repClient;

import MonitoredEntities.*;
import EventEvaluator.Resource.*;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class EntityTypeClient {

  private Utilities.Console cs;
  private EntityRepository eREP;

  public EntityTypeClient(Utilities.Console cs, EntityRepository eREP) {
    this.cs = cs;
    this.eREP = eREP;
  }
  
    public void add(){
	String metid = cs.readString("metid: ");
	String description = cs.readString("description: ");
	try {
	    eREP.add_metype(metid, description);
	    System.out.println("added entity type "+metid+" !");
	}
	catch (EntityTypeAlreadyExist etae) {
	  System.out.println("entity type"+metid+" already exist !");
	}
    }
    
    public void delete(){
      String metid = cs.readString("metid: ");
	try {
	  eREP.erase_metype(metid);
	  System.out.println("entity type "+metid+" deleted !");
	}
	catch (NoSuchEntityType nset) {
	  System.out.println("entity type"+metid+" does not exist !");
	}
	catch (RIViolate riv) {
	  System.out.println("Relational Integrity Violation ! "+metid+" not deleted !");
	}
    }

    public void list(){
      String metid = cs.readString("metid: ");
	try {
	  EntityType et = eREP.get_metype_ref(metid);
	  System.out.println(et.metid());
	  System.out.println(et.description());
	}
	catch (NoSuchEntityType nset) {
	  System.out.println("entity type "+metid+" does not exist !");
	}
    }
}
