package repClient;

import EventEvaluator.Interaction.*;
import EventEvaluator.*;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class InteractionEventClient {

    private Utilities.Console cs;
    private InteractionEventRepository ieREP;

  public InteractionEventClient(Utilities.Console cs, InteractionEventRepository ieREP) {
    this.cs = cs;
    this.ieREP = ieREP;
  }
  
    public void add(){
	String eid = cs.readString("eid: ");
	String description = cs.readString("description: ");
	int frequency = cs.readInt("frequency: ");
	String class_name = cs.readString("class name: ");
	try {
	    InteractionEvent ie = ieREP.store_interaction_event(eid, description, frequency, 
							      class_name);
	    System.out.println("added interaction event "+eid+" !");
	}
	catch (EventAlreadyExist eae) {
	  System.out.println("interaction event "+eid+" already exist !");
	}
	catch (EventClassNotFound ecnf) {
	  System.out.println("interaction event "+eid+" class not found !");
	}
    }
    
    public void delete(){
      String eid = cs.readString("eid: ");
	try {
	  ieREP.erase(eid);
	  System.out.println("interaction event "+eid+" deleted !");
	}
	catch (NoSuchEvent nse) {
	  System.out.println("interaction event "+eid+" does not exist !");
	}
    }

    public void list(){
      String eid = cs.readString("eid: ");
	try {
	    // System.out.println("scientific debug");
	    InteractionEvent ie = ieREP.get_ie_ref(eid);
	    System.out.println(ie.eid());
	    System.out.println(ie.description());
	    System.out.println(ie.frequency());
	    // System.out.println("putz grila !!!!!!!!");
	    // String sl = new String();
	    // sl = ie.class_name();
	    System.out.println(ie.class_name());
	}
	catch (NoSuchEvent nse) {
	  System.out.println("interaction event "+eid+" does not exist !");
	}
    }
}
