package repClient;

import MonitoredEntities.*;
import EventEvaluator.Resource.*;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class ParameterClient {

  private Utilities.Console cs;
  private EntityRepository eREP;

  public ParameterClient(Utilities.Console cs, EntityRepository eREP) {
    this.cs = cs;
    this.eREP = eREP;
  }
  
    public void add(){
	String pid = cs.readString("pid: ");
	String description = cs.readString("description: ");
	String metid = cs.readString("metid: ");
	try {
	    EntityType et = eREP.get_metype_ref(metid);
	    System.out.println("Add range list. Enter 0 and 0 on initial and final range values when finished.");
	    Vector vranges = new Vector();
	    boolean out = false;
	    int i=0;
	    do {
		System.out.println("   Enter parameter["+i+"]");
		double initialv = cs.readDouble("      initial range:");
		double finalv = cs.readDouble("      final range:");
		if (initialv==0 && finalv==0)
		    out = true;
		else {
		    range newrange = new range(initialv, finalv);
		    vranges.add(newrange);
		    i++;
		}
	    } while(out==false);
	    range[] rangeList = new range[vranges.size()];
	    i=0;
	    for (Enumeration e = vranges.elements() ; e.hasMoreElements() ;) {
		rangeList[i] = (range)e.nextElement();
		i++;
	    }
	    eREP.add_parameter(pid, description, et, rangeList);
	    System.out.println("added parameter "+pid+" !");
	}
	catch (NoSuchEntityType nset) {
	  System.out.println("entity type"+metid+" does not exist !");
	}
	catch (ParameterAlreadyExist pae) {
	  System.out.println("parameter "+pid+" already exist !");
	}
    }
    
    public void delete(){
      String pid = cs.readString("pid: ");
	try {
	  eREP.erase_parameter(pid);
	  System.out.println("parameter "+pid+" deleted !");
	}
	catch (NoSuchParameter nsp) {
	  System.out.println("parameter "+pid+" does not exist !");
	}
    }

    public void list(){
      String pid = cs.readString("pid: ");
	try {
	  Parameter p = eREP.get_parameter_ref(pid);
	  System.out.println(p.pid());
	  System.out.println(p.description());
	  EntityType et = p.metype();
	  System.out.println(et.metid());
	  int nr = p.num_ranges();
	  range[] rangeList = new range[nr];
	  rangeList = p.ranges();
	  System.out.println("Range list:");
	  for (int i = 0; i < nr; i++) {
	      System.out.println("   intial value: "+rangeList[i].initial_value);
	      System.out.println("   final value: "+rangeList[i].final_value);
	  }
	}
	catch (NoSuchParameter nsp) {
	  System.out.println("parameter "+pid+" does not exist !");
	}
    }
}


