package repClient;

import MonitoredEntities.*;
import EventEvaluator.Resource.*;
import EventEvaluator.*;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class ResourceEventClient {

    private Utilities.Console cs;
    private ResourceEventRepository reREP;
    private EntityRepository eREP;

  public ResourceEventClient(Utilities.Console cs, ResourceEventRepository reREP,
			     EntityRepository eREP) {
    this.cs = cs;
    this.reREP = reREP;
    this.eREP = eREP;
  }
  
    public void add(){
	String eid = cs.readString("eid: ");
	String description = cs.readString("description: ");
	String expression = cs.readString("expression: ");
	int duration_time = cs.readInt("duration time: ");
	String metid = cs.readString("metid: ");
	try {
	    EntityType et = eREP.get_metype_ref(metid);
	    ResourceEvent re = reREP.store_resource_event(eid, description, expression, 
							  duration_time, et);
	    System.out.println("added resource event "+eid+" !");
	}
	catch (NoSuchEntityType nset) {
	  System.out.println("entity type"+metid+" does not exist !");
	}
	catch (EventAlreadyExist eae) {
	  System.out.println("resource event "+eid+" already exist !");
	}
	catch (InvalidExpression ie) {
	    System.out.println("invalid expression !");
	} 
	catch (ParameterExpressionError per) {
	    System.out.println("Parameter "+per.pid+" on expression does not exist !");
	}
    }
    
    public void delete(){
      String eid = cs.readString("eid: ");
	try {
	  reREP.erase(eid);
	  System.out.println("resource event "+eid+" deleted !");
	}
	catch (NoSuchEvent nse) {
	  System.out.println("resource event "+eid+" does not exist !");
	}
    }

    public void list(){
      String eid = cs.readString("eid: ");
	try {
	  ResourceEvent re = reREP.get_re_ref(eid);
	  System.out.println(re.eid());
	  System.out.println(re.description());
	  System.out.println(re.expression());
	  System.out.println(re.duration_time());
	  EntityType et = re.metype();
	  System.out.println(et.metid());
	}
	catch (NoSuchEvent nse) {
	  System.out.println("resource event "+eid+" does not exist !");
	}
    }
}
