/*
 * Created on Jan 19, 2004
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package soundtest;

import java.io.IOException;
import java.net.InetAddress;

import javax.media.MediaLocator;
import javax.media.NoDataSourceException;
import javax.media.NoProcessorException;
import javax.media.control.TrackControl;
import javax.media.protocol.ContentDescriptor;
import javax.media.protocol.DataSource;
import javax.media.protocol.PullBufferDataSource;
import javax.media.protocol.PullBufferStream;
import javax.media.protocol.PushBufferDataSource;
import javax.media.protocol.PushBufferStream;
import javax.media.rtp.RTPManager;
import javax.media.rtp.SendStream;
import javax.media.rtp.SessionAddress;
import javax.media.rtp.rtcp.SourceDescription;
import javax.media.*;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class JMFTeste
{

	public static void main(String[] args)
	{
		MediaLocator locator = new MediaLocator("file:/root/bh.wav");
		DataSource ds = null;
		DataSource dataOutput; 
		
		// Processor
		
		try
		{
			ds = Manager.createDataSource(locator);
		} catch (NoDataSourceException e)
		{	
			e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		
		Processor proc = null;
		try
		{
			proc = Manager.createProcessor(ds);
		} catch (NoProcessorException e1)
		{
			e1.printStackTrace();
		} catch (IOException e1)
		{
			e1.printStackTrace();
		}
	
		proc.configure();
		while(proc.getState()!=Processor.Configured);
		
		TrackControl [] tracks = proc.getTrackControls();
		if(tracks == null || tracks.length < 1)
		{
			System.out.println("Pau nas tracks");
			return;
		}
		
		ContentDescriptor cd = new ContentDescriptor(ContentDescriptor.RAW_RTP);
		proc.setContentDescriptor(cd);
		
		Format supported[];
		Format chosen;
			
		for(int i=0; i<tracks.length; i++)
		{
			System.out.println("Track "+i);
			
			Format format=tracks[i].getFormat();
			if(tracks[i].isEnabled())
			{
				supported = tracks[i].getSupportedFormats();
				if(supported.length > 0)
				{
					chosen=supported[0];
					tracks[i].setFormat(chosen);
				}
			}
		}
		
		proc.realize();
		while(proc.getState()!=Processor.Realized);
		
		dataOutput = proc.getDataOutput();
		
		// Transmitter
		//PullBufferDataSource pbds = (PullBufferDataSource)dataOutput;
		//PullBufferStream pbs[] = pbds.getStreams();
		PushBufferDataSource pbds = (PushBufferDataSource)dataOutput;
		PushBufferStream pbs[] = pbds.getStreams();
		
		RTPManager rtpMgrs[] = new RTPManager[pbs.length];
		SessionAddress localAddr, destAddr;
		InetAddress ipAddr;
		SendStream sendStream;
		int port;
		SourceDescription srcDesList[];

		for (int i = 0; i < pbs.length; i++)
		{
			try
			{
				rtpMgrs[i] = RTPManager.newInstance();
					    
				port = 5570 + 2*i;
				ipAddr = InetAddress.getByName("localhost");

				localAddr = new SessionAddress( InetAddress.getLocalHost(),
								5567);
		
				destAddr = new SessionAddress(ipAddr, 8000);

				rtpMgrs[i].initialize( localAddr);
		
				rtpMgrs[i].addTarget( destAddr);
		
				System.out.println( "Created RTP session: " + "localhost" + " " + port);
		
				sendStream = rtpMgrs[i].createSendStream(dataOutput, i);		
				sendStream.start();
			} 
			catch (Exception  e) {
				e.printStackTrace();
			}
		}
		
		proc.start();
	}
}
