/*
 * Created on Jan 10, 2004
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package soundtest;

import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.Vector;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.UnsupportedAudioFileException;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class soundTest
{

	public static void main(String[] args)
	{
		Vector streams = new Vector();
		//File audio1 = new File("/root/bh.wav");
		//File audio2 = new File("/root/rnr.wav");
		File audio1 = new File("/usr/local/movies/bitb.mp3");
		File audio2 = new File("/usr/local/movies/Goldfinger - 99 Red Ballons.mp3");
		
		AudioInputStream ais = null;
		AudioInputStream ais2 = null;
		/*AudioInputStream ais3 = null;
		AudioInputStream ais4 = null;
		AudioInputStream ais5 = null;
		AudioInputStream ais6 = null;*/
		
		try
		{
			ais = AudioSystem.getAudioInputStream(audio1);
			ais2 = AudioSystem.getAudioInputStream(audio2);
			/*ais3 = AudioSystem.getAudioInputStream(audio1);
			ais4 = AudioSystem.getAudioInputStream(audio1);
			ais5 = AudioSystem.getAudioInputStream(audio2);
			ais6 = AudioSystem.getAudioInputStream(audio2);*/
		} catch (UnsupportedAudioFileException e)
		{
			e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		
		AudioFormat af=ais.getFormat();
		AudioFormat af2=ais2.getFormat();
		DataLine.Info info = new DataLine.Info(SourceDataLine.class, af, 40960);
		DataLine.Info info2 = new DataLine.Info(SourceDataLine.class, af2, 40960);
		
		boolean	bIsSupportedDirectly = AudioSystem.isLineSupported(info);
		if (!bIsSupportedDirectly)
		{
			AudioFormat sourceFormat = af;
			AudioFormat targetFormat = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, sourceFormat.getSampleRate(),
						16, sourceFormat.getChannels(), sourceFormat.getChannels() * (16/8), sourceFormat.getSampleRate(),
						false);
			System.out.println("AudioPlayer.main(): source format: " + sourceFormat);
			System.out.println("AudioPlayer.main(): target format: " + targetFormat);
			ais = AudioSystem.getAudioInputStream(targetFormat, ais);
			af = ais.getFormat();
			System.out.println("AudioPlayer.main(): converted AIS: " + ais);
			System.out.println("AudioPlayer.main(): converted format: " + af);
		}
		
		boolean	bIsSupportedDirectly2 = AudioSystem.isLineSupported(info2);
		if (!bIsSupportedDirectly2)
		{
			AudioFormat sourceFormat = af2;
			AudioFormat targetFormat = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, sourceFormat.getSampleRate(),
						16, sourceFormat.getChannels(), sourceFormat.getChannels() * (16/8), sourceFormat.getSampleRate(),
						false);
			System.out.println("AudioPlayer.main(): source format: " + sourceFormat);
			System.out.println("AudioPlayer.main(): target format: " + targetFormat);
			ais2 = AudioSystem.getAudioInputStream(targetFormat, ais2);
			af2 = ais2.getFormat();
			System.out.println("AudioPlayer.main(): converted AIS: " + ais2);
			System.out.println("AudioPlayer.main(): converted format: " + af2);
		}

		SourceDataLine line = getSourceDataLine(null, af, 40960);
		if (line == null)
		{
			System.out.println("AudioPlayer: cannot get SourceDataLine for format " + af);
			System.exit(1);
		}
		
		System.out.println("AudioPlayer.main(): line: " + line);
		System.out.println("AudioPlayer.main(): line format: " + line.getFormat());
		
		streams.add(ais);
		streams.add(ais2);
		/*streams.add(ais3);
		streams.add(ais4);
		streams.add(ais5);
		streams.add(ais6);*/
		
		line.start();
		
		byte[]	orgData = new byte[128000];
		byte[]	mixedData = new byte[128000];
				
		int nBytesRead = 0;
		int nBytesReadTotal = 0;
		
//		while (nBytesRead != -1)
//		{
//			try
//			{
//				nBytesRead = ais.read(orgData, 0, orgData.length);
//			}
//			catch (IOException e)
//			{
//				e.printStackTrace();
//			}
//			if (nBytesRead >= 0)
//			{
//				int	nBytesWritten = line.write(orgData, 0, nBytesRead);
//			}
//		}
		
		while(!streams.isEmpty())
		{
			mixedData = new byte[128000];
			Iterator itStr = streams.iterator();
			
			while(itStr.hasNext())
			{	
				try
				{
					AudioInputStream str = (AudioInputStream)itStr.next();
					nBytesRead=str.read(orgData, 0, orgData.length);
						
					if(nBytesRead==-1)
					{
						itStr.remove();				
					}
				}
				catch(IOException e)
				{
					e.printStackTrace();
				}
				
				// Mixing
				for(int i=0; i<nBytesRead; i++)
				{
					mixedData[i]+=orgData[i]/streams.size();
				}
				
				nBytesReadTotal = Math.max(nBytesRead, nBytesReadTotal);
			}
			
			int	nBytesWritten = line.write(mixedData, 0, nBytesReadTotal);
		}
		
		line.drain();
		line.close();
		System.out.println("Acabou!!");
	}
	
	private static SourceDataLine getSourceDataLine(String strMixerName,
								AudioFormat audioFormat,
								int nBufferSize)
	{
		/*
		 *	Asking for a line is a rather tricky thing.
		 *	We have to construct an Info object that specifies
		 *	the desired properties for the line.
		 *	First, we have to say which kind of line we want. The
		 *	possibilities are: SourceDataLine (for playback), Clip
		 *	(for repeated playback)	and TargetDataLine (for
		 *	 recording).
		 *	Here, we want to do normal playback, so we ask for
		 *	a SourceDataLine.
		 *	Then, we have to pass an AudioFormat object, so that
		 *	the Line knows which format the data passed to it
		 *	will have.
		 *	Furthermore, we can give Java Sound a hint about how
		 *	big the internal buffer for the line should be. This
		 *	isn't used here, signaling that we
		 *	don't care about the exact size. Java Sound will use
		 *	some default value for the buffer size.
		 */
		SourceDataLine	line = null;
		DataLine.Info	info = new DataLine.Info(SourceDataLine.class,
							 audioFormat, nBufferSize);
		try
		{
			if (strMixerName != null)
			{
				Mixer.Info	mixerInfo = AudioCommon.getMixerInfo(strMixerName);
				if (mixerInfo == null)
				{
					System.out.println("AudioPlayer: mixer not found: " + strMixerName);
					System.exit(1);
				}
				Mixer	mixer = AudioSystem.getMixer(mixerInfo);
				line = (SourceDataLine) mixer.getLine(info);
			}
			else
			{
				line = (SourceDataLine) AudioSystem.getLine(info);
			}

			/*
			 *	The line is there, but it is not yet ready to
			 *	receive audio data. We have to open the line.
			 */
			line.open(audioFormat, nBufferSize);
		}
		catch (LineUnavailableException e)
		{
			e.printStackTrace();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return line;
	}
}
