type CPU_RT_PCPT = contract {
    period: decreasing numeric usec;
    peakProcessing_per_period: decreasing numeric;    
};

// Teste de um tipo de comentrio
type CPU_RT_PCCPT = contract {
    period: decreasing numeric usec;
    peakProcessing_per_period: decreasing numeric;    
};

type CPU_RT_PVPT = contract {
    period: decreasing numeric usec;
    peakProcessing_per_period: decreasing numeric;
    sustainableProcessing_per_period: decreasing numeric;
    burstTolerance: decreasing numeric;
};

type CPU_RT_ACPU = contract {
    peakProcessingUtil: decreasing numeric;
};

type CPU_RT_EVENT = contract {
    period: decreasing numeric usec;
    peakProcessing_in_period: decreasing numeric;    
};

processamentoIdeal = CPU_RT_PCPT contract {
    period = 40;
    peakProcessing_per_period = 0.25;
};

processamentoComDimensaoErrada = CPU_RT_PCPT contract {
    periodMax = 40;
    peakProcessing_per_period = 0.25;
};

processamentoComTipoDeContratoErrado = PeriodicConstantProcessingTime contract {
    period = 100;
    peakProcessing_per_period = 0.20;
};

processamentoMinimo = CPU_RT_PCPT contract {
    period = 100;
    peakProcessing_per_period = 0.20;
};

idealProfile for mpeg_player = profile {
    require processamentoIdeal;
};

minimoProfile for mpeg_player = profile {
    require processamentoMinimo;
};

profileComContratoErrado1 for mpeg_player = profile {
    require processamentoComDimensaoErrada;
};

profileComContratoErrado2 for mpeg_player = profile {
    require processamentoComTipoDeContratoErrado;
};




