/*
 * Created on Jun 30, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.util.Iterator;
import java.util.Vector;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorServer extends Thread
{
	ServerSocket server;
	boolean keepWaiting;
	Vector connectionHandlers;
	
	public ReflectorServer() throws IOException
	{
		server = new ServerSocket(5567);		
		keepWaiting = true;
		this.connectionHandlers=new Vector();
	}
	
	public void run()
	{
		// Checks each second if the thread was stopped
		try
		{
			server.setSoTimeout(1000);
		} catch (SocketException e1)
		{
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		Socket connection = null;
		while(keepWaiting)
		{
			
				try
				{
					connection = server.accept();
					ReflectorConnectionHandler handler = new ReflectorConnectionHandler(connection);
					this.connectionHandlers.add(handler);
					handler.start();
				} catch (InterruptedIOException e)
				{
					System.out.println("Keep waiting...");
				} 
				catch (IOException e)
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
	}
	
	public void stopWaiting()
	{
		keepWaiting=false;
		try
		{
			this.server.close();
		} catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		stopHandlers();
	}

	/**
	 * 
	 */
	private void stopHandlers()
	{
		// TODO Iterar sobre o vetor de connectionhandlers parando cada uma das threads
		Iterator handlers=this.connectionHandlers.iterator();
		while(handlers.hasNext())
		{
			ReflectorConnectionHandler h=(ReflectorConnectionHandler)handlers.next();
			h.stopSending();			
		}
	}
}
